/* Catacomb Apocalypse Source Code
 * Copyright (C) 1993-2014 Flat Rock Software
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

// New file used for preparing and converting pointers to states

#include "def.h"

REFKEEN_NS_B

// The exact segment of a 32-bit far pointer depends on location of DOS EXE
// in memory, so make it possible to configure it
static uint_fast32_t g_farPtrExeLocSegOffset;

// List of all states
extern statetype s_pshot1;
extern statetype s_pshot2;
extern statetype s_pshot_exp1;
extern statetype s_pshot_exp2;
extern statetype s_pshot_exp3;
extern statetype s_player;
extern statetype s_explode;
extern statetype s_boltbonus;
extern statetype s_boltbonus2;
extern statetype s_boltbonus3;
extern statetype s_nukebonus;
extern statetype s_nukebonus2;
extern statetype s_nukebonus3;
extern statetype s_potionbonus;
extern statetype s_rkeybonus;
extern statetype s_ykeybonus;
extern statetype s_gkeybonus;
extern statetype s_bkeybonus;
extern statetype s_chestbonus;
extern statetype s_oldchestbonus;
extern statetype s_waterchestbonus1;
extern statetype s_waterchestbonus2;
extern statetype s_waterchestbonus3;
extern statetype s_rgem1bonus;
extern statetype s_ygem1bonus;
extern statetype s_ggem1bonus;
extern statetype s_bgem1bonus;
extern statetype s_pgem1bonus;
extern statetype s_bonus_die;
extern statetype s_ftimebonus;
extern statetype s_ftimebonus2;
extern statetype s_walldie1;
extern statetype s_walldie2;
extern statetype s_walldie3;
extern statetype s_walldie4;
extern statetype s_walldie5;
extern statetype s_walldie6;
extern statetype s_portal_wait;
extern statetype s_portal1;
extern statetype s_portal2;
extern statetype s_portal3;
extern statetype s_portal4;
extern statetype s_portal5;
extern statetype s_portal6;
extern statetype s_aqua_under1;
extern statetype s_aqua_under2;
extern statetype s_aqua_under3;
extern statetype s_aqua_left;
extern statetype s_aqua_right;
extern statetype s_aqua_rise1;
extern statetype s_aqua_rise2;
extern statetype s_aqua_sink1;
extern statetype s_aqua_sink2;
extern statetype s_aqua_walk1;
extern statetype s_aqua_walk2;
extern statetype s_aqua_attack1;
extern statetype s_aqua_attack2;
extern statetype s_aqua_die1;
extern statetype s_aqua_die2;
extern statetype s_aqua_die3;
extern statetype s_aqua_die4;
extern statetype s_aqua_die5;
extern statetype s_aqua_die6;
extern statetype s_aqua_die7;
extern statetype s_wizard_walk1;
extern statetype s_wizard_walk2;
extern statetype s_wizard_walk3;
extern statetype s_wizard_walk4;
extern statetype s_wizard_attack1;
extern statetype s_wizard_attack2;
extern statetype s_wizard_ouch;
extern statetype s_wizard_die1;
extern statetype s_wizard_die2;
extern statetype s_wizard_die3;
extern statetype s_wizard_die4;
extern statetype s_wizard_shoot1;
extern statetype s_wizard_shoot2;
extern statetype s_wizard_shoot3;
extern statetype s_wizard_shot1;
extern statetype s_wizard_shot2;
extern statetype s_ray_under;
extern statetype s_ray_rise;
extern statetype s_ray_sink;
extern statetype s_ray_fly1;
extern statetype s_ray_fly2;
extern statetype s_ray_fly3;
extern statetype s_ray_fly4;
extern statetype s_ray_attack1;
extern statetype s_ray_attack2;
extern statetype s_ray_attack3;
extern statetype s_ray_die1;
extern statetype s_ray_die2;
extern statetype s_ray_shot1;
extern statetype s_ray_shot2;
extern statetype s_blob_gnd1;
extern statetype s_blob_gnd2;
extern statetype s_blob_rise1;
extern statetype s_blob_rise2;
extern statetype s_blob_sink1;
extern statetype s_blob_sink2;
extern statetype s_blob_walk1;
extern statetype s_blob_walk2;
extern statetype s_blob_walk3;
extern statetype s_blob_ouch;
extern statetype s_blob_die1;
extern statetype s_blob_die2;
extern statetype s_blob_die3;
extern statetype s_blob_shot1;
extern statetype s_blob_shot2;
extern statetype s_skel_1;
extern statetype s_skel_2;
extern statetype s_skel_3;
extern statetype s_skel_4;
extern statetype s_skel_attack1;
extern statetype s_skel_attack2;
extern statetype s_skel_attack3;
extern statetype s_skel_attack4;
extern statetype s_skel_ouch;
extern statetype s_skel_die1;
extern statetype s_skel_die2;
extern statetype s_skel_die3;
extern statetype s_skel_shot1;
extern statetype s_skel_shot2;
extern statetype s_fmage1;
extern statetype s_fmage2;
extern statetype s_fmage3;
extern statetype s_fmageattack1;
extern statetype s_fmageattack2;
extern statetype s_fmageattack3;
extern statetype s_fmageouch;
extern statetype s_fmagedie1;
extern statetype s_fmagedie2;
extern statetype s_fmagedie3;
extern statetype s_fmshot1;
extern statetype s_fmshot2;
extern statetype s_robotank_walk1;
extern statetype s_robotank_walk2;
extern statetype s_robotank_walk3;
extern statetype s_robotank_walk4;
extern statetype s_robotank_attack1;
extern statetype s_robotank_attack2;
extern statetype s_robotank_attack3;
extern statetype s_robotank_attack4;
extern statetype s_robotank_death1;
extern statetype s_robotank_death2;
extern statetype s_robotank_death3;
extern statetype s_robotank_death4;
extern statetype s_robotank_death5;
extern statetype s_robotank_shot1;
extern statetype s_robotank_shot2;
extern statetype s_stompy_walk1;
extern statetype s_stompy_walk2;
extern statetype s_stompy_walk3;
extern statetype s_stompy_walk4;
extern statetype s_stompy_attack1;
extern statetype s_stompy_attack2;
extern statetype s_stompy_attack3;
extern statetype s_stompy_attack4;
extern statetype s_stompy_ouch;
extern statetype s_stompy_death1;
extern statetype s_stompy_death2;
extern statetype s_stompy_death3;
extern statetype s_stompy_death4;
extern statetype s_stompy_shot1;
extern statetype s_stompy_shot2;
extern statetype s_stompy_shot3;
extern statetype s_stompy_shot4;
extern statetype s_stompy_shot5;
extern statetype s_bug_walk1;
extern statetype s_bug_walk2;
extern statetype s_bug_walk3;
extern statetype s_bug_attack1;
extern statetype s_bug_attack2;
extern statetype s_bug_attack3;
extern statetype s_bug_attack4;
extern statetype s_bug_ouch;
extern statetype s_bug_death1;
extern statetype s_bug_death2;
extern statetype s_bug_shot1;
extern statetype s_bug_shot2;
extern statetype s_eye_pause;
extern statetype s_eye_1;
extern statetype s_eye_2;
extern statetype s_eye_3;
extern statetype s_eye_4;
extern statetype s_eye_shootplayer_1;
extern statetype s_eye_shootplayer_2;
extern statetype s_eye_ouch;
extern statetype s_eye_ouch2;
extern statetype s_eye_die1;
extern statetype s_eye_die2;
extern statetype s_eye_die3;
extern statetype s_eye_die4;
extern statetype s_eshot1;
extern statetype s_eshot2;
extern statetype s_reye_1;
extern statetype s_reye_2;
extern statetype s_reye_3;
extern statetype s_reye_4;
extern statetype s_reye_ouch;
extern statetype s_reye_ouch2;
extern statetype s_reye_die1;
extern statetype s_reye_die2;
extern statetype s_reye_die3;
extern statetype s_reye_die4;
extern statetype s_head;
extern statetype s_head_shot1;
extern statetype s_head_shot2;
extern statetype s_demonpause;
extern statetype s_demon1;
extern statetype s_demon2;
extern statetype s_demon3;
extern statetype s_demon4;
extern statetype s_demonattack1;
extern statetype s_demonattack2;
extern statetype s_demonattack3;
extern statetype s_demonouch;
extern statetype s_demondie1;
extern statetype s_demondie2;
extern statetype s_demondie3;
extern statetype s_trollpause;
extern statetype s_troll1;
extern statetype s_troll2;
extern statetype s_troll3;
extern statetype s_troll4;
extern statetype s_trollattack1;
extern statetype s_trollattack2;
extern statetype s_trollouch;
extern statetype s_trolldie1;
extern statetype s_trolldie2;
extern statetype s_trolldie3;
extern statetype s_cyborg_demon1;
extern statetype s_cyborg_demon2;
extern statetype s_cyborg_demon3;
extern statetype s_cyborg_demon4;
extern statetype s_cyborg_demonattack1;
extern statetype s_cyborg_demonattack2;
extern statetype s_cyborg_demonattack3;
extern statetype s_cyborg_demonouch;
extern statetype s_cyborg_demondie1;
extern statetype s_cyborg_demondie2;
extern statetype s_cyborg_demondie3;
extern statetype s_invis_fizz1;
extern statetype s_invis_fizz2;
extern statetype s_invis_fizz3;
extern statetype s_invis_walk;
extern statetype s_invis_attack;
extern statetype s_invis_pause;
extern statetype s_invis_flash1;
extern statetype s_invis_flash2;
extern statetype s_invis_flash3;
extern statetype s_invis_death1;
extern statetype s_invis_death2;
extern statetype s_invis_death3;
extern statetype s_bounce1;
extern statetype s_bounce2;
extern statetype s_grelpause;
extern statetype s_grel1;
extern statetype s_grel2;
extern statetype s_grelattack3;
extern statetype s_grelouch;
extern statetype s_greldie1;
extern statetype s_greldie2;
extern statetype s_greldie3;
extern statetype s_greldie4;
extern statetype s_greldie5;
extern statetype s_greldie5a;
extern statetype s_greldie6;
extern statetype s_gshot1;
extern statetype s_column1;
extern statetype s_column2;
extern statetype s_column3;
extern statetype s_column4;
extern statetype s_column5;
extern statetype s_ffire_pot;
extern statetype s_ofire_pot1;
extern statetype s_ofire_pot2;
extern statetype s_tomb1;
extern statetype s_tomb2;
extern statetype s_force_field_1;
extern statetype s_force_field_2;
extern statetype s_force_field_3;
extern statetype s_force_field_4;
extern statetype s_force_field_die;
extern statetype s_force_field_die1;
extern statetype s_invis_wall_control;

static statetype *RefKeen_GetObjStatePtrFromDOSPointer_CatApoc101(uint_fast32_t dosptr);

statetype * (*RefKeen_GetObjStatePtrFromDOSPointer)(uint_fast32_t dosptr) = RefKeen_GetObjStatePtrFromDOSPointer_CatApoc101;

void RefKeen_FillObjStatesWithDOSPointers(void)
{
	g_farPtrExeLocSegOffset = ((uint_fast32_t)BE_Cross_Compat_GetFarPtrRelocationSegOffset()) * 0x10000;
	s_pshot1.compatdospointer = 0x1A6A0000 + g_farPtrExeLocSegOffset;
	s_pshot2.compatdospointer = 0x1A6B0000 + g_farPtrExeLocSegOffset;
	s_pshot_exp1.compatdospointer = 0x1A6C0000 + g_farPtrExeLocSegOffset;
	s_pshot_exp2.compatdospointer = 0x1A6D0000 + g_farPtrExeLocSegOffset;
	s_pshot_exp3.compatdospointer = 0x1A6E0000 + g_farPtrExeLocSegOffset;
	s_player.compatdospointer = 0x1A6F0000 + g_farPtrExeLocSegOffset;
	s_explode.compatdospointer = 0x1A700000 + g_farPtrExeLocSegOffset;
	s_boltbonus.compatdospointer = 0x1A710000 + g_farPtrExeLocSegOffset;
	s_boltbonus2.compatdospointer = 0x1A720000 + g_farPtrExeLocSegOffset;
	s_boltbonus3.compatdospointer = 0x1A730000 + g_farPtrExeLocSegOffset;
	s_nukebonus.compatdospointer = 0x1A740000 + g_farPtrExeLocSegOffset;
	s_nukebonus2.compatdospointer = 0x1A750000 + g_farPtrExeLocSegOffset;
	s_nukebonus3.compatdospointer = 0x1A760000 + g_farPtrExeLocSegOffset;
	s_potionbonus.compatdospointer = 0x1A770000 + g_farPtrExeLocSegOffset;
	s_rkeybonus.compatdospointer = 0x1A780000 + g_farPtrExeLocSegOffset;
	s_ykeybonus.compatdospointer = 0x1A790000 + g_farPtrExeLocSegOffset;
	s_gkeybonus.compatdospointer = 0x1A7A0000 + g_farPtrExeLocSegOffset;
	s_bkeybonus.compatdospointer = 0x1A7B0000 + g_farPtrExeLocSegOffset;
	s_chestbonus.compatdospointer = 0x1A7C0000 + g_farPtrExeLocSegOffset;
	s_oldchestbonus.compatdospointer = 0x1A7D0000 + g_farPtrExeLocSegOffset;
	s_waterchestbonus1.compatdospointer = 0x1A7E0000 + g_farPtrExeLocSegOffset;
	s_waterchestbonus2.compatdospointer = 0x1A7F0000 + g_farPtrExeLocSegOffset;
	s_waterchestbonus3.compatdospointer = 0x1A800000 + g_farPtrExeLocSegOffset;
	s_rgem1bonus.compatdospointer = 0x1A810000 + g_farPtrExeLocSegOffset;
	s_ygem1bonus.compatdospointer = 0x1A820000 + g_farPtrExeLocSegOffset;
	s_ggem1bonus.compatdospointer = 0x1A830000 + g_farPtrExeLocSegOffset;
	s_bgem1bonus.compatdospointer = 0x1A840000 + g_farPtrExeLocSegOffset;
	s_pgem1bonus.compatdospointer = 0x1A850000 + g_farPtrExeLocSegOffset;
	s_bonus_die.compatdospointer = 0x1A860000 + g_farPtrExeLocSegOffset;
	s_ftimebonus.compatdospointer = 0x1A870000 + g_farPtrExeLocSegOffset;
	s_ftimebonus2.compatdospointer = 0x1A880000 + g_farPtrExeLocSegOffset;
	s_walldie1.compatdospointer = 0x1A890000 + g_farPtrExeLocSegOffset;
	s_walldie2.compatdospointer = 0x1A8A0000 + g_farPtrExeLocSegOffset;
	s_walldie3.compatdospointer = 0x1A8B0000 + g_farPtrExeLocSegOffset;
	s_walldie4.compatdospointer = 0x1A8C0000 + g_farPtrExeLocSegOffset;
	s_walldie5.compatdospointer = 0x1A8D0000 + g_farPtrExeLocSegOffset;
	s_walldie6.compatdospointer = 0x1A8E0000 + g_farPtrExeLocSegOffset;
	s_portal_wait.compatdospointer = 0x1A8F0000 + g_farPtrExeLocSegOffset;
	s_portal1.compatdospointer = 0x1A900000 + g_farPtrExeLocSegOffset;
	s_portal2.compatdospointer = 0x1A910000 + g_farPtrExeLocSegOffset;
	s_portal3.compatdospointer = 0x1A920000 + g_farPtrExeLocSegOffset;
	s_portal4.compatdospointer = 0x1A930000 + g_farPtrExeLocSegOffset;
	s_portal5.compatdospointer = 0x1A940000 + g_farPtrExeLocSegOffset;
	s_portal6.compatdospointer = 0x1A950000 + g_farPtrExeLocSegOffset;
	s_aqua_under1.compatdospointer = 0x1A960000 + g_farPtrExeLocSegOffset;
	s_aqua_under2.compatdospointer = 0x1A970000 + g_farPtrExeLocSegOffset;
	s_aqua_under3.compatdospointer = 0x1A980000 + g_farPtrExeLocSegOffset;
	s_aqua_left.compatdospointer = 0x1A990000 + g_farPtrExeLocSegOffset;
	s_aqua_right.compatdospointer = 0x1A9A0000 + g_farPtrExeLocSegOffset;
	s_aqua_rise1.compatdospointer = 0x1A9B0000 + g_farPtrExeLocSegOffset;
	s_aqua_rise2.compatdospointer = 0x1A9C0000 + g_farPtrExeLocSegOffset;
	s_aqua_sink1.compatdospointer = 0x1A9D0000 + g_farPtrExeLocSegOffset;
	s_aqua_sink2.compatdospointer = 0x1A9E0000 + g_farPtrExeLocSegOffset;
	s_aqua_walk1.compatdospointer = 0x1A9F0000 + g_farPtrExeLocSegOffset;
	s_aqua_walk2.compatdospointer = 0x1AA00000 + g_farPtrExeLocSegOffset;
	s_aqua_attack1.compatdospointer = 0x1AA10000 + g_farPtrExeLocSegOffset;
	s_aqua_attack2.compatdospointer = 0x1AA20000 + g_farPtrExeLocSegOffset;
	s_aqua_die1.compatdospointer = 0x1AA30000 + g_farPtrExeLocSegOffset;
	s_aqua_die2.compatdospointer = 0x1AA40000 + g_farPtrExeLocSegOffset;
	s_aqua_die3.compatdospointer = 0x1AA50000 + g_farPtrExeLocSegOffset;
	s_aqua_die4.compatdospointer = 0x1AA60000 + g_farPtrExeLocSegOffset;
	s_aqua_die5.compatdospointer = 0x1AA70000 + g_farPtrExeLocSegOffset;
	s_aqua_die6.compatdospointer = 0x1AA80000 + g_farPtrExeLocSegOffset;
	s_aqua_die7.compatdospointer = 0x1AA90000 + g_farPtrExeLocSegOffset;
	s_wizard_walk1.compatdospointer = 0x1AAA0000 + g_farPtrExeLocSegOffset;
	s_wizard_walk2.compatdospointer = 0x1AAB0000 + g_farPtrExeLocSegOffset;
	s_wizard_walk3.compatdospointer = 0x1AAC0000 + g_farPtrExeLocSegOffset;
	s_wizard_walk4.compatdospointer = 0x1AAD0000 + g_farPtrExeLocSegOffset;
	s_wizard_attack1.compatdospointer = 0x1AAE0000 + g_farPtrExeLocSegOffset;
	s_wizard_attack2.compatdospointer = 0x1AAF0000 + g_farPtrExeLocSegOffset;
	s_wizard_ouch.compatdospointer = 0x1AB00000 + g_farPtrExeLocSegOffset;
	s_wizard_die1.compatdospointer = 0x1AB10000 + g_farPtrExeLocSegOffset;
	s_wizard_die2.compatdospointer = 0x1AB20000 + g_farPtrExeLocSegOffset;
	s_wizard_die3.compatdospointer = 0x1AB30000 + g_farPtrExeLocSegOffset;
	s_wizard_die4.compatdospointer = 0x1AB40000 + g_farPtrExeLocSegOffset;
	s_wizard_shoot1.compatdospointer = 0x1AB50000 + g_farPtrExeLocSegOffset;
	s_wizard_shoot2.compatdospointer = 0x1AB60000 + g_farPtrExeLocSegOffset;
	s_wizard_shoot3.compatdospointer = 0x1AB70000 + g_farPtrExeLocSegOffset;
	s_wizard_shot1.compatdospointer = 0x1AB80000 + g_farPtrExeLocSegOffset;
	s_wizard_shot2.compatdospointer = 0x1AB90000 + g_farPtrExeLocSegOffset;
	s_ray_under.compatdospointer = 0x1ABA0000 + g_farPtrExeLocSegOffset;
	s_ray_rise.compatdospointer = 0x1ABB0000 + g_farPtrExeLocSegOffset;
	s_ray_sink.compatdospointer = 0x1ABC0000 + g_farPtrExeLocSegOffset;
	s_ray_fly1.compatdospointer = 0x1ABD0000 + g_farPtrExeLocSegOffset;
	s_ray_fly2.compatdospointer = 0x1ABE0000 + g_farPtrExeLocSegOffset;
	s_ray_fly3.compatdospointer = 0x1ABF0000 + g_farPtrExeLocSegOffset;
	s_ray_fly4.compatdospointer = 0x1AC00000 + g_farPtrExeLocSegOffset;
	s_ray_attack1.compatdospointer = 0x1AC10000 + g_farPtrExeLocSegOffset;
	s_ray_attack2.compatdospointer = 0x1AC20000 + g_farPtrExeLocSegOffset;
	s_ray_attack3.compatdospointer = 0x1AC30000 + g_farPtrExeLocSegOffset;
	s_ray_die1.compatdospointer = 0x1AC40000 + g_farPtrExeLocSegOffset;
	s_ray_die2.compatdospointer = 0x1AC50000 + g_farPtrExeLocSegOffset;
	s_ray_shot1.compatdospointer = 0x1AC60000 + g_farPtrExeLocSegOffset;
	s_ray_shot2.compatdospointer = 0x1AC70000 + g_farPtrExeLocSegOffset;
	s_blob_gnd1.compatdospointer = 0x1AC80000 + g_farPtrExeLocSegOffset;
	s_blob_gnd2.compatdospointer = 0x1AC90000 + g_farPtrExeLocSegOffset;
	s_blob_rise1.compatdospointer = 0x1ACA0000 + g_farPtrExeLocSegOffset;
	s_blob_rise2.compatdospointer = 0x1ACB0000 + g_farPtrExeLocSegOffset;
	s_blob_sink1.compatdospointer = 0x1ACC0000 + g_farPtrExeLocSegOffset;
	s_blob_sink2.compatdospointer = 0x1ACD0000 + g_farPtrExeLocSegOffset;
	s_blob_walk1.compatdospointer = 0x1ACE0000 + g_farPtrExeLocSegOffset;
	s_blob_walk2.compatdospointer = 0x1ACF0000 + g_farPtrExeLocSegOffset;
	s_blob_walk3.compatdospointer = 0x1AD00000 + g_farPtrExeLocSegOffset;
	s_blob_ouch.compatdospointer = 0x1AD10000 + g_farPtrExeLocSegOffset;
	s_blob_die1.compatdospointer = 0x1AD20000 + g_farPtrExeLocSegOffset;
	s_blob_die2.compatdospointer = 0x1AD30000 + g_farPtrExeLocSegOffset;
	s_blob_die3.compatdospointer = 0x1AD40000 + g_farPtrExeLocSegOffset;
	s_blob_shot1.compatdospointer = 0x1AD50000 + g_farPtrExeLocSegOffset;
	s_blob_shot2.compatdospointer = 0x1AD60000 + g_farPtrExeLocSegOffset;
	s_skel_1.compatdospointer = 0x1AD70000 + g_farPtrExeLocSegOffset;
	s_skel_2.compatdospointer = 0x1AD80000 + g_farPtrExeLocSegOffset;
	s_skel_3.compatdospointer = 0x1AD90000 + g_farPtrExeLocSegOffset;
	s_skel_4.compatdospointer = 0x1ADA0000 + g_farPtrExeLocSegOffset;
	s_skel_attack1.compatdospointer = 0x1ADB0000 + g_farPtrExeLocSegOffset;
	s_skel_attack2.compatdospointer = 0x1ADC0000 + g_farPtrExeLocSegOffset;
	s_skel_attack3.compatdospointer = 0x1ADD0000 + g_farPtrExeLocSegOffset;
	s_skel_attack4.compatdospointer = 0x1ADE0000 + g_farPtrExeLocSegOffset;
	s_skel_ouch.compatdospointer = 0x1ADF0000 + g_farPtrExeLocSegOffset;
	s_skel_die1.compatdospointer = 0x1AE00000 + g_farPtrExeLocSegOffset;
	s_skel_die2.compatdospointer = 0x1AE10000 + g_farPtrExeLocSegOffset;
	s_skel_die3.compatdospointer = 0x1AE20000 + g_farPtrExeLocSegOffset;
	s_skel_shot1.compatdospointer = 0x1AE30000 + g_farPtrExeLocSegOffset;
	s_skel_shot2.compatdospointer = 0x1AE40000 + g_farPtrExeLocSegOffset;
	s_fmage1.compatdospointer = 0x1AE50000 + g_farPtrExeLocSegOffset;
	s_fmage2.compatdospointer = 0x1AE60000 + g_farPtrExeLocSegOffset;
	s_fmage3.compatdospointer = 0x1AE70000 + g_farPtrExeLocSegOffset;
	s_fmageattack1.compatdospointer = 0x1AE80000 + g_farPtrExeLocSegOffset;
	s_fmageattack2.compatdospointer = 0x1AE90000 + g_farPtrExeLocSegOffset;
	s_fmageattack3.compatdospointer = 0x1AEA0000 + g_farPtrExeLocSegOffset;
	s_fmageouch.compatdospointer = 0x1AEB0000 + g_farPtrExeLocSegOffset;
	s_fmagedie1.compatdospointer = 0x1AEC0000 + g_farPtrExeLocSegOffset;
	s_fmagedie2.compatdospointer = 0x1AED0000 + g_farPtrExeLocSegOffset;
	s_fmagedie3.compatdospointer = 0x1AEE0000 + g_farPtrExeLocSegOffset;
	s_fmshot1.compatdospointer = 0x1AEF0000 + g_farPtrExeLocSegOffset;
	s_fmshot2.compatdospointer = 0x1AF00000 + g_farPtrExeLocSegOffset;
	s_robotank_walk1.compatdospointer = 0x1AF10000 + g_farPtrExeLocSegOffset;
	s_robotank_walk2.compatdospointer = 0x1AF20000 + g_farPtrExeLocSegOffset;
	s_robotank_walk3.compatdospointer = 0x1AF30000 + g_farPtrExeLocSegOffset;
	s_robotank_walk4.compatdospointer = 0x1AF40000 + g_farPtrExeLocSegOffset;
	s_robotank_attack1.compatdospointer = 0x1AF50000 + g_farPtrExeLocSegOffset;
	s_robotank_attack2.compatdospointer = 0x1AF60000 + g_farPtrExeLocSegOffset;
	s_robotank_attack3.compatdospointer = 0x1AF70000 + g_farPtrExeLocSegOffset;
	s_robotank_attack4.compatdospointer = 0x1AF80000 + g_farPtrExeLocSegOffset;
	s_robotank_death1.compatdospointer = 0x1AF90000 + g_farPtrExeLocSegOffset;
	s_robotank_death2.compatdospointer = 0x1AFA0000 + g_farPtrExeLocSegOffset;
	s_robotank_death3.compatdospointer = 0x1AFB0000 + g_farPtrExeLocSegOffset;
	s_robotank_death4.compatdospointer = 0x1AFC0000 + g_farPtrExeLocSegOffset;
	s_robotank_death5.compatdospointer = 0x1AFD0000 + g_farPtrExeLocSegOffset;
	s_robotank_shot1.compatdospointer = 0x1AFE0000 + g_farPtrExeLocSegOffset;
	s_robotank_shot2.compatdospointer = 0x1AFF0000 + g_farPtrExeLocSegOffset;
	s_stompy_walk1.compatdospointer = 0x1B000000 + g_farPtrExeLocSegOffset;
	s_stompy_walk2.compatdospointer = 0x1B010000 + g_farPtrExeLocSegOffset;
	s_stompy_walk3.compatdospointer = 0x1B020000 + g_farPtrExeLocSegOffset;
	s_stompy_walk4.compatdospointer = 0x1B030000 + g_farPtrExeLocSegOffset;
	s_stompy_attack1.compatdospointer = 0x1B040000 + g_farPtrExeLocSegOffset;
	s_stompy_attack2.compatdospointer = 0x1B050000 + g_farPtrExeLocSegOffset;
	s_stompy_attack3.compatdospointer = 0x1B060000 + g_farPtrExeLocSegOffset;
	s_stompy_attack4.compatdospointer = 0x1B070000 + g_farPtrExeLocSegOffset;
	s_stompy_ouch.compatdospointer = 0x1B080000 + g_farPtrExeLocSegOffset;
	s_stompy_death1.compatdospointer = 0x1B090000 + g_farPtrExeLocSegOffset;
	s_stompy_death2.compatdospointer = 0x1B0A0000 + g_farPtrExeLocSegOffset;
	s_stompy_death3.compatdospointer = 0x1B0B0000 + g_farPtrExeLocSegOffset;
	s_stompy_death4.compatdospointer = 0x1B0C0000 + g_farPtrExeLocSegOffset;
	s_stompy_shot1.compatdospointer = 0x1B0D0000 + g_farPtrExeLocSegOffset;
	s_stompy_shot2.compatdospointer = 0x1B0E0000 + g_farPtrExeLocSegOffset;
	s_stompy_shot3.compatdospointer = 0x1B0F0000 + g_farPtrExeLocSegOffset;
	s_stompy_shot4.compatdospointer = 0x1B100000 + g_farPtrExeLocSegOffset;
	s_stompy_shot5.compatdospointer = 0x1B110000 + g_farPtrExeLocSegOffset;
	s_bug_walk1.compatdospointer = 0x1B120000 + g_farPtrExeLocSegOffset;
	s_bug_walk2.compatdospointer = 0x1B130000 + g_farPtrExeLocSegOffset;
	s_bug_walk3.compatdospointer = 0x1B140000 + g_farPtrExeLocSegOffset;
	s_bug_attack1.compatdospointer = 0x1B150000 + g_farPtrExeLocSegOffset;
	s_bug_attack2.compatdospointer = 0x1B160000 + g_farPtrExeLocSegOffset;
	s_bug_attack3.compatdospointer = 0x1B170000 + g_farPtrExeLocSegOffset;
	s_bug_attack4.compatdospointer = 0x1B180000 + g_farPtrExeLocSegOffset;
	s_bug_ouch.compatdospointer = 0x1B190000 + g_farPtrExeLocSegOffset;
	s_bug_death1.compatdospointer = 0x1B1A0000 + g_farPtrExeLocSegOffset;
	s_bug_death2.compatdospointer = 0x1B1B0000 + g_farPtrExeLocSegOffset;
	s_bug_shot1.compatdospointer = 0x1B1C0000 + g_farPtrExeLocSegOffset;
	s_bug_shot2.compatdospointer = 0x1B1D0000 + g_farPtrExeLocSegOffset;
	s_eye_pause.compatdospointer = 0x1B1E0000 + g_farPtrExeLocSegOffset;
	s_eye_1.compatdospointer = 0x1B1F0000 + g_farPtrExeLocSegOffset;
	s_eye_2.compatdospointer = 0x1B200000 + g_farPtrExeLocSegOffset;
	s_eye_3.compatdospointer = 0x1B210000 + g_farPtrExeLocSegOffset;
	s_eye_4.compatdospointer = 0x1B220000 + g_farPtrExeLocSegOffset;
	s_eye_shootplayer_1.compatdospointer = 0x1B230000 + g_farPtrExeLocSegOffset;
	s_eye_shootplayer_2.compatdospointer = 0x1B240000 + g_farPtrExeLocSegOffset;
	s_eye_ouch.compatdospointer = 0x1B250000 + g_farPtrExeLocSegOffset;
	s_eye_ouch2.compatdospointer = 0x1B260000 + g_farPtrExeLocSegOffset;
	s_eye_die1.compatdospointer = 0x1B270000 + g_farPtrExeLocSegOffset;
	s_eye_die2.compatdospointer = 0x1B280000 + g_farPtrExeLocSegOffset;
	s_eye_die3.compatdospointer = 0x1B290000 + g_farPtrExeLocSegOffset;
	s_eye_die4.compatdospointer = 0x1B2A0000 + g_farPtrExeLocSegOffset;
	s_eshot1.compatdospointer = 0x1B2B0000 + g_farPtrExeLocSegOffset;
	s_eshot2.compatdospointer = 0x1B2C0000 + g_farPtrExeLocSegOffset;
	s_reye_1.compatdospointer = 0x1B2D0000 + g_farPtrExeLocSegOffset;
	s_reye_2.compatdospointer = 0x1B2E0000 + g_farPtrExeLocSegOffset;
	s_reye_3.compatdospointer = 0x1B2F0000 + g_farPtrExeLocSegOffset;
	s_reye_4.compatdospointer = 0x1B300000 + g_farPtrExeLocSegOffset;
	s_reye_ouch.compatdospointer = 0x1B310000 + g_farPtrExeLocSegOffset;
	s_reye_ouch2.compatdospointer = 0x1B320000 + g_farPtrExeLocSegOffset;
	s_reye_die1.compatdospointer = 0x1B330000 + g_farPtrExeLocSegOffset;
	s_reye_die2.compatdospointer = 0x1B340000 + g_farPtrExeLocSegOffset;
	s_reye_die3.compatdospointer = 0x1B350000 + g_farPtrExeLocSegOffset;
	s_reye_die4.compatdospointer = 0x1B360000 + g_farPtrExeLocSegOffset;
	s_head.compatdospointer = 0x1B370000 + g_farPtrExeLocSegOffset;
	s_head_shot1.compatdospointer = 0x1B380000 + g_farPtrExeLocSegOffset;
	s_head_shot2.compatdospointer = 0x1B390000 + g_farPtrExeLocSegOffset;
	s_demonpause.compatdospointer = 0x1B3A0000 + g_farPtrExeLocSegOffset;
	s_demon1.compatdospointer = 0x1B3B0000 + g_farPtrExeLocSegOffset;
	s_demon2.compatdospointer = 0x1B3C0000 + g_farPtrExeLocSegOffset;
	s_demon3.compatdospointer = 0x1B3D0000 + g_farPtrExeLocSegOffset;
	s_demon4.compatdospointer = 0x1B3E0000 + g_farPtrExeLocSegOffset;
	s_demonattack1.compatdospointer = 0x1B3F0000 + g_farPtrExeLocSegOffset;
	s_demonattack2.compatdospointer = 0x1B400000 + g_farPtrExeLocSegOffset;
	s_demonattack3.compatdospointer = 0x1B410000 + g_farPtrExeLocSegOffset;
	s_demonouch.compatdospointer = 0x1B420000 + g_farPtrExeLocSegOffset;
	s_demondie1.compatdospointer = 0x1B430000 + g_farPtrExeLocSegOffset;
	s_demondie2.compatdospointer = 0x1B440000 + g_farPtrExeLocSegOffset;
	s_demondie3.compatdospointer = 0x1B450000 + g_farPtrExeLocSegOffset;
	s_trollpause.compatdospointer = 0x1B460000 + g_farPtrExeLocSegOffset;
	s_troll1.compatdospointer = 0x1B470000 + g_farPtrExeLocSegOffset;
	s_troll2.compatdospointer = 0x1B480000 + g_farPtrExeLocSegOffset;
	s_troll3.compatdospointer = 0x1B490000 + g_farPtrExeLocSegOffset;
	s_troll4.compatdospointer = 0x1B4A0000 + g_farPtrExeLocSegOffset;
	s_trollattack1.compatdospointer = 0x1B4B0000 + g_farPtrExeLocSegOffset;
	s_trollattack2.compatdospointer = 0x1B4C0000 + g_farPtrExeLocSegOffset;
	s_trollouch.compatdospointer = 0x1B4D0000 + g_farPtrExeLocSegOffset;
	s_trolldie1.compatdospointer = 0x1B4E0000 + g_farPtrExeLocSegOffset;
	s_trolldie2.compatdospointer = 0x1B4F0000 + g_farPtrExeLocSegOffset;
	s_trolldie3.compatdospointer = 0x1B500000 + g_farPtrExeLocSegOffset;
	s_cyborg_demon1.compatdospointer = 0x1B510000 + g_farPtrExeLocSegOffset;
	s_cyborg_demon2.compatdospointer = 0x1B520000 + g_farPtrExeLocSegOffset;
	s_cyborg_demon3.compatdospointer = 0x1B530000 + g_farPtrExeLocSegOffset;
	s_cyborg_demon4.compatdospointer = 0x1B540000 + g_farPtrExeLocSegOffset;
	s_cyborg_demonattack1.compatdospointer = 0x1B550000 + g_farPtrExeLocSegOffset;
	s_cyborg_demonattack2.compatdospointer = 0x1B560000 + g_farPtrExeLocSegOffset;
	s_cyborg_demonattack3.compatdospointer = 0x1B570000 + g_farPtrExeLocSegOffset;
	s_cyborg_demonouch.compatdospointer = 0x1B580000 + g_farPtrExeLocSegOffset;
	s_cyborg_demondie1.compatdospointer = 0x1B590000 + g_farPtrExeLocSegOffset;
	s_cyborg_demondie2.compatdospointer = 0x1B5A0000 + g_farPtrExeLocSegOffset;
	s_cyborg_demondie3.compatdospointer = 0x1B5B0000 + g_farPtrExeLocSegOffset;
	s_invis_fizz1.compatdospointer = 0x1B5C0000 + g_farPtrExeLocSegOffset;
	s_invis_fizz2.compatdospointer = 0x1B5D0000 + g_farPtrExeLocSegOffset;
	s_invis_fizz3.compatdospointer = 0x1B5E0000 + g_farPtrExeLocSegOffset;
	s_invis_walk.compatdospointer = 0x1B5F0000 + g_farPtrExeLocSegOffset;
	s_invis_attack.compatdospointer = 0x1B600000 + g_farPtrExeLocSegOffset;
	s_invis_pause.compatdospointer = 0x1B610000 + g_farPtrExeLocSegOffset;
	s_invis_flash1.compatdospointer = 0x1B620000 + g_farPtrExeLocSegOffset;
	s_invis_flash2.compatdospointer = 0x1B630000 + g_farPtrExeLocSegOffset;
	s_invis_flash3.compatdospointer = 0x1B640000 + g_farPtrExeLocSegOffset;
	s_invis_death1.compatdospointer = 0x1B650000 + g_farPtrExeLocSegOffset;
	s_invis_death2.compatdospointer = 0x1B660000 + g_farPtrExeLocSegOffset;
	s_invis_death3.compatdospointer = 0x1B670000 + g_farPtrExeLocSegOffset;
	s_bounce1.compatdospointer = 0x1B680000 + g_farPtrExeLocSegOffset;
	s_bounce2.compatdospointer = 0x1B690000 + g_farPtrExeLocSegOffset;
	s_grelpause.compatdospointer = 0x1B6A0000 + g_farPtrExeLocSegOffset;
	s_grel1.compatdospointer = 0x1B6B0000 + g_farPtrExeLocSegOffset;
	s_grel2.compatdospointer = 0x1B6C0000 + g_farPtrExeLocSegOffset;
	s_grelattack3.compatdospointer = 0x1B6D0000 + g_farPtrExeLocSegOffset;
	s_grelouch.compatdospointer = 0x1B6E0000 + g_farPtrExeLocSegOffset;
	s_greldie1.compatdospointer = 0x1B6F0000 + g_farPtrExeLocSegOffset;
	s_greldie2.compatdospointer = 0x1B700000 + g_farPtrExeLocSegOffset;
	s_greldie3.compatdospointer = 0x1B710000 + g_farPtrExeLocSegOffset;
	s_greldie4.compatdospointer = 0x1B720000 + g_farPtrExeLocSegOffset;
	s_greldie5.compatdospointer = 0x1B730000 + g_farPtrExeLocSegOffset;
	s_greldie5a.compatdospointer = 0x1B740000 + g_farPtrExeLocSegOffset;
	s_greldie6.compatdospointer = 0x1B750000 + g_farPtrExeLocSegOffset;
	s_gshot1.compatdospointer = 0x1B760000 + g_farPtrExeLocSegOffset;
	s_column1.compatdospointer = 0x1B770000 + g_farPtrExeLocSegOffset;
	s_column2.compatdospointer = 0x1B780000 + g_farPtrExeLocSegOffset;
	s_column3.compatdospointer = 0x1B790000 + g_farPtrExeLocSegOffset;
	s_column4.compatdospointer = 0x1B7A0000 + g_farPtrExeLocSegOffset;
	s_column5.compatdospointer = 0x1B7B0000 + g_farPtrExeLocSegOffset;
	s_ffire_pot.compatdospointer = 0x1B7C0000 + g_farPtrExeLocSegOffset;
	s_ofire_pot1.compatdospointer = 0x1B7D0000 + g_farPtrExeLocSegOffset;
	s_ofire_pot2.compatdospointer = 0x1B7E0000 + g_farPtrExeLocSegOffset;
	s_tomb1.compatdospointer = 0x1B7F0000 + g_farPtrExeLocSegOffset;
	s_tomb2.compatdospointer = 0x1B800000 + g_farPtrExeLocSegOffset;
	s_force_field_1.compatdospointer = 0x1B810000 + g_farPtrExeLocSegOffset;
	s_force_field_2.compatdospointer = 0x1B820000 + g_farPtrExeLocSegOffset;
	s_force_field_3.compatdospointer = 0x1B830000 + g_farPtrExeLocSegOffset;
	s_force_field_4.compatdospointer = 0x1B840000 + g_farPtrExeLocSegOffset;
	s_force_field_die.compatdospointer = 0x1B850000 + g_farPtrExeLocSegOffset;
	s_force_field_die1.compatdospointer = 0x1B860000 + g_farPtrExeLocSegOffset;
	s_invis_wall_control.compatdospointer = 0x1B870000 + g_farPtrExeLocSegOffset;
}

statetype *RefKeen_GetObjStatePtrFromDOSPointer_CatApoc101(uint_fast32_t dosptr)
{
	switch (dosptr - g_farPtrExeLocSegOffset)
	{
	case 0x1A6A0000: return &s_pshot1;
	case 0x1A6B0000: return &s_pshot2;
	case 0x1A6C0000: return &s_pshot_exp1;
	case 0x1A6D0000: return &s_pshot_exp2;
	case 0x1A6E0000: return &s_pshot_exp3;
	case 0x1A6F0000: return &s_player;
	case 0x1A700000: return &s_explode;
	case 0x1A710000: return &s_boltbonus;
	case 0x1A720000: return &s_boltbonus2;
	case 0x1A730000: return &s_boltbonus3;
	case 0x1A740000: return &s_nukebonus;
	case 0x1A750000: return &s_nukebonus2;
	case 0x1A760000: return &s_nukebonus3;
	case 0x1A770000: return &s_potionbonus;
	case 0x1A780000: return &s_rkeybonus;
	case 0x1A790000: return &s_ykeybonus;
	case 0x1A7A0000: return &s_gkeybonus;
	case 0x1A7B0000: return &s_bkeybonus;
	case 0x1A7C0000: return &s_chestbonus;
	case 0x1A7D0000: return &s_oldchestbonus;
	case 0x1A7E0000: return &s_waterchestbonus1;
	case 0x1A7F0000: return &s_waterchestbonus2;
	case 0x1A800000: return &s_waterchestbonus3;
	case 0x1A810000: return &s_rgem1bonus;
	case 0x1A820000: return &s_ygem1bonus;
	case 0x1A830000: return &s_ggem1bonus;
	case 0x1A840000: return &s_bgem1bonus;
	case 0x1A850000: return &s_pgem1bonus;
	case 0x1A860000: return &s_bonus_die;
	case 0x1A870000: return &s_ftimebonus;
	case 0x1A880000: return &s_ftimebonus2;
	case 0x1A890000: return &s_walldie1;
	case 0x1A8A0000: return &s_walldie2;
	case 0x1A8B0000: return &s_walldie3;
	case 0x1A8C0000: return &s_walldie4;
	case 0x1A8D0000: return &s_walldie5;
	case 0x1A8E0000: return &s_walldie6;
	case 0x1A8F0000: return &s_portal_wait;
	case 0x1A900000: return &s_portal1;
	case 0x1A910000: return &s_portal2;
	case 0x1A920000: return &s_portal3;
	case 0x1A930000: return &s_portal4;
	case 0x1A940000: return &s_portal5;
	case 0x1A950000: return &s_portal6;
	case 0x1A960000: return &s_aqua_under1;
	case 0x1A970000: return &s_aqua_under2;
	case 0x1A980000: return &s_aqua_under3;
	case 0x1A990000: return &s_aqua_left;
	case 0x1A9A0000: return &s_aqua_right;
	case 0x1A9B0000: return &s_aqua_rise1;
	case 0x1A9C0000: return &s_aqua_rise2;
	case 0x1A9D0000: return &s_aqua_sink1;
	case 0x1A9E0000: return &s_aqua_sink2;
	case 0x1A9F0000: return &s_aqua_walk1;
	case 0x1AA00000: return &s_aqua_walk2;
	case 0x1AA10000: return &s_aqua_attack1;
	case 0x1AA20000: return &s_aqua_attack2;
	case 0x1AA30000: return &s_aqua_die1;
	case 0x1AA40000: return &s_aqua_die2;
	case 0x1AA50000: return &s_aqua_die3;
	case 0x1AA60000: return &s_aqua_die4;
	case 0x1AA70000: return &s_aqua_die5;
	case 0x1AA80000: return &s_aqua_die6;
	case 0x1AA90000: return &s_aqua_die7;
	case 0x1AAA0000: return &s_wizard_walk1;
	case 0x1AAB0000: return &s_wizard_walk2;
	case 0x1AAC0000: return &s_wizard_walk3;
	case 0x1AAD0000: return &s_wizard_walk4;
	case 0x1AAE0000: return &s_wizard_attack1;
	case 0x1AAF0000: return &s_wizard_attack2;
	case 0x1AB00000: return &s_wizard_ouch;
	case 0x1AB10000: return &s_wizard_die1;
	case 0x1AB20000: return &s_wizard_die2;
	case 0x1AB30000: return &s_wizard_die3;
	case 0x1AB40000: return &s_wizard_die4;
	case 0x1AB50000: return &s_wizard_shoot1;
	case 0x1AB60000: return &s_wizard_shoot2;
	case 0x1AB70000: return &s_wizard_shoot3;
	case 0x1AB80000: return &s_wizard_shot1;
	case 0x1AB90000: return &s_wizard_shot2;
	case 0x1ABA0000: return &s_ray_under;
	case 0x1ABB0000: return &s_ray_rise;
	case 0x1ABC0000: return &s_ray_sink;
	case 0x1ABD0000: return &s_ray_fly1;
	case 0x1ABE0000: return &s_ray_fly2;
	case 0x1ABF0000: return &s_ray_fly3;
	case 0x1AC00000: return &s_ray_fly4;
	case 0x1AC10000: return &s_ray_attack1;
	case 0x1AC20000: return &s_ray_attack2;
	case 0x1AC30000: return &s_ray_attack3;
	case 0x1AC40000: return &s_ray_die1;
	case 0x1AC50000: return &s_ray_die2;
	case 0x1AC60000: return &s_ray_shot1;
	case 0x1AC70000: return &s_ray_shot2;
	case 0x1AC80000: return &s_blob_gnd1;
	case 0x1AC90000: return &s_blob_gnd2;
	case 0x1ACA0000: return &s_blob_rise1;
	case 0x1ACB0000: return &s_blob_rise2;
	case 0x1ACC0000: return &s_blob_sink1;
	case 0x1ACD0000: return &s_blob_sink2;
	case 0x1ACE0000: return &s_blob_walk1;
	case 0x1ACF0000: return &s_blob_walk2;
	case 0x1AD00000: return &s_blob_walk3;
	case 0x1AD10000: return &s_blob_ouch;
	case 0x1AD20000: return &s_blob_die1;
	case 0x1AD30000: return &s_blob_die2;
	case 0x1AD40000: return &s_blob_die3;
	case 0x1AD50000: return &s_blob_shot1;
	case 0x1AD60000: return &s_blob_shot2;
	case 0x1AD70000: return &s_skel_1;
	case 0x1AD80000: return &s_skel_2;
	case 0x1AD90000: return &s_skel_3;
	case 0x1ADA0000: return &s_skel_4;
	case 0x1ADB0000: return &s_skel_attack1;
	case 0x1ADC0000: return &s_skel_attack2;
	case 0x1ADD0000: return &s_skel_attack3;
	case 0x1ADE0000: return &s_skel_attack4;
	case 0x1ADF0000: return &s_skel_ouch;
	case 0x1AE00000: return &s_skel_die1;
	case 0x1AE10000: return &s_skel_die2;
	case 0x1AE20000: return &s_skel_die3;
	case 0x1AE30000: return &s_skel_shot1;
	case 0x1AE40000: return &s_skel_shot2;
	case 0x1AE50000: return &s_fmage1;
	case 0x1AE60000: return &s_fmage2;
	case 0x1AE70000: return &s_fmage3;
	case 0x1AE80000: return &s_fmageattack1;
	case 0x1AE90000: return &s_fmageattack2;
	case 0x1AEA0000: return &s_fmageattack3;
	case 0x1AEB0000: return &s_fmageouch;
	case 0x1AEC0000: return &s_fmagedie1;
	case 0x1AED0000: return &s_fmagedie2;
	case 0x1AEE0000: return &s_fmagedie3;
	case 0x1AEF0000: return &s_fmshot1;
	case 0x1AF00000: return &s_fmshot2;
	case 0x1AF10000: return &s_robotank_walk1;
	case 0x1AF20000: return &s_robotank_walk2;
	case 0x1AF30000: return &s_robotank_walk3;
	case 0x1AF40000: return &s_robotank_walk4;
	case 0x1AF50000: return &s_robotank_attack1;
	case 0x1AF60000: return &s_robotank_attack2;
	case 0x1AF70000: return &s_robotank_attack3;
	case 0x1AF80000: return &s_robotank_attack4;
	case 0x1AF90000: return &s_robotank_death1;
	case 0x1AFA0000: return &s_robotank_death2;
	case 0x1AFB0000: return &s_robotank_death3;
	case 0x1AFC0000: return &s_robotank_death4;
	case 0x1AFD0000: return &s_robotank_death5;
	case 0x1AFE0000: return &s_robotank_shot1;
	case 0x1AFF0000: return &s_robotank_shot2;
	case 0x1B000000: return &s_stompy_walk1;
	case 0x1B010000: return &s_stompy_walk2;
	case 0x1B020000: return &s_stompy_walk3;
	case 0x1B030000: return &s_stompy_walk4;
	case 0x1B040000: return &s_stompy_attack1;
	case 0x1B050000: return &s_stompy_attack2;
	case 0x1B060000: return &s_stompy_attack3;
	case 0x1B070000: return &s_stompy_attack4;
	case 0x1B080000: return &s_stompy_ouch;
	case 0x1B090000: return &s_stompy_death1;
	case 0x1B0A0000: return &s_stompy_death2;
	case 0x1B0B0000: return &s_stompy_death3;
	case 0x1B0C0000: return &s_stompy_death4;
	case 0x1B0D0000: return &s_stompy_shot1;
	case 0x1B0E0000: return &s_stompy_shot2;
	case 0x1B0F0000: return &s_stompy_shot3;
	case 0x1B100000: return &s_stompy_shot4;
	case 0x1B110000: return &s_stompy_shot5;
	case 0x1B120000: return &s_bug_walk1;
	case 0x1B130000: return &s_bug_walk2;
	case 0x1B140000: return &s_bug_walk3;
	case 0x1B150000: return &s_bug_attack1;
	case 0x1B160000: return &s_bug_attack2;
	case 0x1B170000: return &s_bug_attack3;
	case 0x1B180000: return &s_bug_attack4;
	case 0x1B190000: return &s_bug_ouch;
	case 0x1B1A0000: return &s_bug_death1;
	case 0x1B1B0000: return &s_bug_death2;
	case 0x1B1C0000: return &s_bug_shot1;
	case 0x1B1D0000: return &s_bug_shot2;
	case 0x1B1E0000: return &s_eye_pause;
	case 0x1B1F0000: return &s_eye_1;
	case 0x1B200000: return &s_eye_2;
	case 0x1B210000: return &s_eye_3;
	case 0x1B220000: return &s_eye_4;
	case 0x1B230000: return &s_eye_shootplayer_1;
	case 0x1B240000: return &s_eye_shootplayer_2;
	case 0x1B250000: return &s_eye_ouch;
	case 0x1B260000: return &s_eye_ouch2;
	case 0x1B270000: return &s_eye_die1;
	case 0x1B280000: return &s_eye_die2;
	case 0x1B290000: return &s_eye_die3;
	case 0x1B2A0000: return &s_eye_die4;
	case 0x1B2B0000: return &s_eshot1;
	case 0x1B2C0000: return &s_eshot2;
	case 0x1B2D0000: return &s_reye_1;
	case 0x1B2E0000: return &s_reye_2;
	case 0x1B2F0000: return &s_reye_3;
	case 0x1B300000: return &s_reye_4;
	case 0x1B310000: return &s_reye_ouch;
	case 0x1B320000: return &s_reye_ouch2;
	case 0x1B330000: return &s_reye_die1;
	case 0x1B340000: return &s_reye_die2;
	case 0x1B350000: return &s_reye_die3;
	case 0x1B360000: return &s_reye_die4;
	case 0x1B370000: return &s_head;
	case 0x1B380000: return &s_head_shot1;
	case 0x1B390000: return &s_head_shot2;
	case 0x1B3A0000: return &s_demonpause;
	case 0x1B3B0000: return &s_demon1;
	case 0x1B3C0000: return &s_demon2;
	case 0x1B3D0000: return &s_demon3;
	case 0x1B3E0000: return &s_demon4;
	case 0x1B3F0000: return &s_demonattack1;
	case 0x1B400000: return &s_demonattack2;
	case 0x1B410000: return &s_demonattack3;
	case 0x1B420000: return &s_demonouch;
	case 0x1B430000: return &s_demondie1;
	case 0x1B440000: return &s_demondie2;
	case 0x1B450000: return &s_demondie3;
	case 0x1B460000: return &s_trollpause;
	case 0x1B470000: return &s_troll1;
	case 0x1B480000: return &s_troll2;
	case 0x1B490000: return &s_troll3;
	case 0x1B4A0000: return &s_troll4;
	case 0x1B4B0000: return &s_trollattack1;
	case 0x1B4C0000: return &s_trollattack2;
	case 0x1B4D0000: return &s_trollouch;
	case 0x1B4E0000: return &s_trolldie1;
	case 0x1B4F0000: return &s_trolldie2;
	case 0x1B500000: return &s_trolldie3;
	case 0x1B510000: return &s_cyborg_demon1;
	case 0x1B520000: return &s_cyborg_demon2;
	case 0x1B530000: return &s_cyborg_demon3;
	case 0x1B540000: return &s_cyborg_demon4;
	case 0x1B550000: return &s_cyborg_demonattack1;
	case 0x1B560000: return &s_cyborg_demonattack2;
	case 0x1B570000: return &s_cyborg_demonattack3;
	case 0x1B580000: return &s_cyborg_demonouch;
	case 0x1B590000: return &s_cyborg_demondie1;
	case 0x1B5A0000: return &s_cyborg_demondie2;
	case 0x1B5B0000: return &s_cyborg_demondie3;
	case 0x1B5C0000: return &s_invis_fizz1;
	case 0x1B5D0000: return &s_invis_fizz2;
	case 0x1B5E0000: return &s_invis_fizz3;
	case 0x1B5F0000: return &s_invis_walk;
	case 0x1B600000: return &s_invis_attack;
	case 0x1B610000: return &s_invis_pause;
	case 0x1B620000: return &s_invis_flash1;
	case 0x1B630000: return &s_invis_flash2;
	case 0x1B640000: return &s_invis_flash3;
	case 0x1B650000: return &s_invis_death1;
	case 0x1B660000: return &s_invis_death2;
	case 0x1B670000: return &s_invis_death3;
	case 0x1B680000: return &s_bounce1;
	case 0x1B690000: return &s_bounce2;
	case 0x1B6A0000: return &s_grelpause;
	case 0x1B6B0000: return &s_grel1;
	case 0x1B6C0000: return &s_grel2;
	case 0x1B6D0000: return &s_grelattack3;
	case 0x1B6E0000: return &s_grelouch;
	case 0x1B6F0000: return &s_greldie1;
	case 0x1B700000: return &s_greldie2;
	case 0x1B710000: return &s_greldie3;
	case 0x1B720000: return &s_greldie4;
	case 0x1B730000: return &s_greldie5;
	case 0x1B740000: return &s_greldie5a;
	case 0x1B750000: return &s_greldie6;
	case 0x1B760000: return &s_gshot1;
	case 0x1B770000: return &s_column1;
	case 0x1B780000: return &s_column2;
	case 0x1B790000: return &s_column3;
	case 0x1B7A0000: return &s_column4;
	case 0x1B7B0000: return &s_column5;
	case 0x1B7C0000: return &s_ffire_pot;
	case 0x1B7D0000: return &s_ofire_pot1;
	case 0x1B7E0000: return &s_ofire_pot2;
	case 0x1B7F0000: return &s_tomb1;
	case 0x1B800000: return &s_tomb2;
	case 0x1B810000: return &s_force_field_1;
	case 0x1B820000: return &s_force_field_2;
	case 0x1B830000: return &s_force_field_3;
	case 0x1B840000: return &s_force_field_4;
	case 0x1B850000: return &s_force_field_die;
	case 0x1B860000: return &s_force_field_die1;
	case 0x1B870000: return &s_invis_wall_control;
	}
	return NULL;
}

REFKEEN_NS_E
