/* Catacomb Armageddon Source Code
 * Copyright (C) 1993-2014 Flat Rock Software
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

// New file used for preparing and converting pointers to states

#include "def.h"

REFKEEN_NS_B

// The exact segment of a 32-bit far pointer depends on location of DOS EXE
// in memory, so make it possible to configure it
static uint_fast32_t g_farPtrExeLocSegOffset;

// List of all states
extern statetype s_pshot1;
extern statetype s_pshot2;
extern statetype s_pshot_exp1;
extern statetype s_pshot_exp2;
extern statetype s_pshot_exp3;
extern statetype s_player;
extern statetype s_explode;
extern statetype s_boltbonus;
extern statetype s_boltbonus2;
extern statetype s_boltbonus3;
extern statetype s_nukebonus;
extern statetype s_nukebonus2;
extern statetype s_nukebonus3;
extern statetype s_potionbonus;
extern statetype s_rkeybonus;
extern statetype s_ykeybonus;
extern statetype s_gkeybonus;
extern statetype s_bkeybonus;
extern statetype s_chestbonus;
extern statetype s_waterchestbonus1;
extern statetype s_waterchestbonus2;
extern statetype s_rgem1bonus;
extern statetype s_ygem1bonus;
extern statetype s_ggem1bonus;
extern statetype s_bgem1bonus;
extern statetype s_pgem1bonus;
extern statetype s_rgem2bonus;
extern statetype s_ygem2bonus;
extern statetype s_ggem2bonus;
extern statetype s_bgem2bonus;
extern statetype s_pgem2bonus;
extern statetype s_bonus_die;
extern statetype s_tombs[3];
extern statetype s_ftimebonus;
extern statetype s_ftimebonus2;
extern statetype s_walldie1;
extern statetype s_walldie2;
extern statetype s_walldie3;
extern statetype s_walldie4;
extern statetype s_walldie5;
extern statetype s_walldie6;
extern statetype s_obj_gate1;
extern statetype s_obj_gate2;
extern statetype s_obj_gate3;
extern statetype s_obj_gate4;
extern statetype s_anthill;
extern statetype s_fatdemon_pause;
extern statetype s_fatdemon_walk1;
extern statetype s_fatdemon_walk2;
extern statetype s_fatdemon_walk3;
extern statetype s_fatdemon_walk4;
extern statetype s_fatdemon_attack1;
extern statetype s_fatdemon_attack2;
extern statetype s_fatdemon_ouch;
extern statetype s_fatdemon_blowup1;
extern statetype s_fatdemon_blowup2;
extern statetype s_fatdemon_blowup3;
extern statetype s_fatdemon_blowup4;
extern statetype s_fatdemon_blowup5;
extern statetype s_fatdemon_blowup6;
extern statetype s_fatdemon_blowup7;
extern statetype s_fatdemon_explode;
extern statetype s_fatdemon_feet;
extern statetype s_wet_bubbles1;
extern statetype s_wet_bubbles2;
extern statetype s_wet_bubbles3;
extern statetype s_wet_peek;
extern statetype s_wet_rise1;
extern statetype s_wet_rise3;
extern statetype s_wet_rise4;
extern statetype s_wet_rise5;
extern statetype s_wet_sink1;
extern statetype s_wet_sink2;
extern statetype s_wet_sink3;
extern statetype s_wet_walk1;
extern statetype s_wet_walk2;
extern statetype s_wet_walk3;
extern statetype s_wet_walk4;
extern statetype s_wet_attack1;
extern statetype s_wet_attack2;
extern statetype s_wet_attack3;
extern statetype s_wet_attack4;
extern statetype s_wet_ouch;
extern statetype s_wet_die1;
extern statetype s_wet_die2;
extern statetype s_wet_die3;
extern statetype s_wet_die4;
extern statetype s_wet_die5;
extern statetype s_dragon_shot1;
extern statetype s_dragon_shot2;
extern statetype s_wallskel;
extern statetype s_wallskel2;
extern statetype s_skel_pause;
extern statetype s_skel_1;
extern statetype s_skel_2;
extern statetype s_skel_3;
extern statetype s_skel_4;
extern statetype s_skel_attack1;
extern statetype s_skel_attack2;
extern statetype s_skel_attack3;
extern statetype s_skel_ouch;
extern statetype s_skel_die1;
extern statetype s_skel_die2;
extern statetype s_skel_die3;
extern statetype s_eye_pause;
extern statetype s_eye_1;
extern statetype s_eye_2;
extern statetype s_eye_3;
extern statetype s_eye_4;
extern statetype s_eye_shootplayer_1;
extern statetype s_eye_shootplayer_2;
extern statetype s_eye_ouch;
extern statetype s_eye_ouch2;
extern statetype s_eye_die1;
extern statetype s_eye_die2;
extern statetype s_eye_die3;
extern statetype s_eshot1;
extern statetype s_eshot2;
extern statetype s_succubus_pause;
extern statetype s_succubus_walk1;
extern statetype s_succubus_walk2;
extern statetype s_succubus_walk3;
extern statetype s_succubus_walk4;
extern statetype s_succubus_attack1;
extern statetype s_succubus_attack2;
extern statetype s_succubus_attack3;
extern statetype s_succubus_ouch;
extern statetype s_succubus_death1;
extern statetype s_succubus_death2;
extern statetype s_succubus_shot1;
extern statetype s_magepause;
extern statetype s_mage1;
extern statetype s_mage2;
extern statetype s_mageattack3;
extern statetype s_mageouch;
extern statetype s_magedie1;
extern statetype s_magedie2;
extern statetype s_mshot1;
extern statetype s_mshot2;
extern statetype s_bunny_left1;
extern statetype s_bunny_left2;
extern statetype s_bunny_left3;
extern statetype s_bunny_right1;
extern statetype s_bunny_right2;
extern statetype s_bunny_right3;
extern statetype s_bunny_meta1;
extern statetype s_bunny_meta2;
extern statetype s_bunny_walk1;
extern statetype s_bunny_walk2;
extern statetype s_bunny_attack1;
extern statetype s_bunny_attack2;
extern statetype s_bunny_ouch;
extern statetype s_bunny_pause;
extern statetype s_bunny_death1;
extern statetype s_bunny_death2;
extern statetype s_bunny_death3;
extern statetype s_red_demonpause;
extern statetype s_red_demon1;
extern statetype s_red_demon2;
extern statetype s_red_demon3;
extern statetype s_red_demon4;
extern statetype s_red_demonattack1;
extern statetype s_red_demonattack2;
extern statetype s_red_demonattack3;
extern statetype s_red_demonouch;
extern statetype s_red_demondie1;
extern statetype s_red_demondie2;
extern statetype s_red_demondie3;
extern statetype s_red_demondie4;
extern statetype s_grelpause;
extern statetype s_grel1;
extern statetype s_grel2;
extern statetype s_grelattack3;
extern statetype s_grelouch;
extern statetype s_greldie1;
extern statetype s_greldie2;
extern statetype s_greldie3;
extern statetype s_greldie4;
extern statetype s_greldie5;
extern statetype s_greldie5a;
extern statetype s_greldie6;
extern statetype s_gshot1;
extern statetype s_bat1;
extern statetype s_bat2;
extern statetype s_bat3;
extern statetype s_bat4;
extern statetype s_batpast;
extern statetype s_batdie1;
extern statetype s_batdie2;
extern statetype s_godesspause;
extern statetype s_godess_statue1;
extern statetype s_godess_statue2;
extern statetype s_godess1;
extern statetype s_godess2;
extern statetype s_godess3;
extern statetype s_godessattack1;
extern statetype s_godessattack2;
extern statetype s_godessattack3;
extern statetype s_godessouch;
extern statetype s_godessdie1;
extern statetype s_godessdie2;
extern statetype s_ant_wait;
extern statetype s_ant_egg;
extern statetype s_ant_walk1;
extern statetype s_ant_walk2;
extern statetype s_ant_walk3;
extern statetype s_ant_attack1;
extern statetype s_ant_pause;
extern statetype s_ant_ouch;
extern statetype s_ant_die1;
extern statetype s_ant_die2;
extern statetype s_ant_die3;
extern statetype s_zombie_risen;
extern statetype s_zombie_pause;
extern statetype s_zombie_inground;
extern statetype s_zombie_rise1;
extern statetype s_zombie_rise2;
extern statetype s_zombie_rise3;
extern statetype s_zombie_rise4;
extern statetype s_zombie_alive1;
extern statetype s_zombie_alive2;
extern statetype s_zombie_alive3;
extern statetype s_zombie_death1;
extern statetype s_zombie_death2;
extern statetype s_zombie_death3;
extern statetype s_zombie_attack;
extern statetype s_zombie_ouch;
extern statetype s_tree_pause;
extern statetype s_tree_idle;
extern statetype s_tree_awakening1;
extern statetype s_tree_awakening2;
extern statetype s_tree_walk1;
extern statetype s_tree_walk2;
extern statetype s_tree_death1;
extern statetype s_tree_death2;
extern statetype s_tree_death3;
extern statetype s_tree_death4;
extern statetype s_tree_death5;
extern statetype s_tree_attack1;
extern statetype s_tree_attack2;
extern statetype s_tree_attack3;
extern statetype s_tree_ouch;
extern statetype s_arch_1;
extern statetype s_arch_2;
extern statetype s_arch_3;
extern statetype s_arch_4;
extern statetype s_arch_5;
extern statetype s_arch_6;
extern statetype s_arch_7;
extern statetype s_arch_8;
extern statetype s_arch_9;
extern statetype s_arch_10;
extern statetype s_arch_11;
extern statetype s_arch_12;
extern statetype s_arch_13;
extern statetype s_column;
extern statetype s_sulphur_gas_1;
extern statetype s_sulphur_gas_2;
extern statetype s_sulphur_gas_3;
extern statetype s_fire_pot_1;
extern statetype s_fire_pot_2;
extern statetype s_fountain;
extern statetype s_force_field_1;
extern statetype s_force_field_2;
extern statetype s_force_field_3;
extern statetype s_force_field_4;
extern statetype s_force_field_die;
extern statetype s_force_field_die1;
extern statetype s_skeleton_hanging;

static statetype *RefKeen_GetObjStatePtrFromDOSPointer_CatArm102(uint_fast32_t dosptr);

statetype * (*RefKeen_GetObjStatePtrFromDOSPointer)(uint_fast32_t dosptr) = RefKeen_GetObjStatePtrFromDOSPointer_CatArm102;

void RefKeen_FillObjStatesWithDOSPointers(void)
{
	g_farPtrExeLocSegOffset = ((uint_fast32_t)BE_Cross_Compat_GetFarPtrRelocationSegOffset()) * 0x10000;
	s_pshot1.compatdospointer = 0x1A530000 + g_farPtrExeLocSegOffset;
	s_pshot2.compatdospointer = 0x1A540000 + g_farPtrExeLocSegOffset;
	s_pshot_exp1.compatdospointer = 0x1A550000 + g_farPtrExeLocSegOffset;
	s_pshot_exp2.compatdospointer = 0x1A560000 + g_farPtrExeLocSegOffset;
	s_pshot_exp3.compatdospointer = 0x1A570000 + g_farPtrExeLocSegOffset;
	s_player.compatdospointer = 0x1A580000 + g_farPtrExeLocSegOffset;
	s_explode.compatdospointer = 0x1A590000 + g_farPtrExeLocSegOffset;
	s_boltbonus.compatdospointer = 0x1A5A0000 + g_farPtrExeLocSegOffset;
	s_boltbonus2.compatdospointer = 0x1A5B0000 + g_farPtrExeLocSegOffset;
	s_boltbonus3.compatdospointer = 0x1A5C0000 + g_farPtrExeLocSegOffset;
	s_nukebonus.compatdospointer = 0x1A5D0000 + g_farPtrExeLocSegOffset;
	s_nukebonus2.compatdospointer = 0x1A5E0000 + g_farPtrExeLocSegOffset;
	s_nukebonus3.compatdospointer = 0x1A5F0000 + g_farPtrExeLocSegOffset;
	s_potionbonus.compatdospointer = 0x1A600000 + g_farPtrExeLocSegOffset;
	s_rkeybonus.compatdospointer = 0x1A610000 + g_farPtrExeLocSegOffset;
	s_ykeybonus.compatdospointer = 0x1A620000 + g_farPtrExeLocSegOffset;
	s_gkeybonus.compatdospointer = 0x1A630000 + g_farPtrExeLocSegOffset;
	s_bkeybonus.compatdospointer = 0x1A640000 + g_farPtrExeLocSegOffset;
	s_chestbonus.compatdospointer = 0x1A650000 + g_farPtrExeLocSegOffset;
	s_waterchestbonus1.compatdospointer = 0x1A660000 + g_farPtrExeLocSegOffset;
	s_waterchestbonus2.compatdospointer = 0x1A670000 + g_farPtrExeLocSegOffset;
	s_rgem1bonus.compatdospointer = 0x1A680000 + g_farPtrExeLocSegOffset;
	s_ygem1bonus.compatdospointer = 0x1A690000 + g_farPtrExeLocSegOffset;
	s_ggem1bonus.compatdospointer = 0x1A6A0000 + g_farPtrExeLocSegOffset;
	s_bgem1bonus.compatdospointer = 0x1A6B0000 + g_farPtrExeLocSegOffset;
	s_pgem1bonus.compatdospointer = 0x1A6C0000 + g_farPtrExeLocSegOffset;
	s_rgem2bonus.compatdospointer = 0x1A6D0000 + g_farPtrExeLocSegOffset;
	s_ygem2bonus.compatdospointer = 0x1A6E0000 + g_farPtrExeLocSegOffset;
	s_ggem2bonus.compatdospointer = 0x1A6F0000 + g_farPtrExeLocSegOffset;
	s_bgem2bonus.compatdospointer = 0x1A700000 + g_farPtrExeLocSegOffset;
	s_pgem2bonus.compatdospointer = 0x1A710000 + g_farPtrExeLocSegOffset;
	s_bonus_die.compatdospointer = 0x1A720000 + g_farPtrExeLocSegOffset;
	s_tombs[0].compatdospointer = 0x1A730000 + g_farPtrExeLocSegOffset;
	s_tombs[1].compatdospointer = 0x1A740000 + g_farPtrExeLocSegOffset;
	s_tombs[2].compatdospointer = 0x1A750000 + g_farPtrExeLocSegOffset;
	s_ftimebonus.compatdospointer = 0x1A760000 + g_farPtrExeLocSegOffset;
	s_ftimebonus2.compatdospointer = 0x1A770000 + g_farPtrExeLocSegOffset;
	s_walldie1.compatdospointer = 0x1A780000 + g_farPtrExeLocSegOffset;
	s_walldie2.compatdospointer = 0x1A790000 + g_farPtrExeLocSegOffset;
	s_walldie3.compatdospointer = 0x1A7A0000 + g_farPtrExeLocSegOffset;
	s_walldie4.compatdospointer = 0x1A7B0000 + g_farPtrExeLocSegOffset;
	s_walldie5.compatdospointer = 0x1A7C0000 + g_farPtrExeLocSegOffset;
	s_walldie6.compatdospointer = 0x1A7D0000 + g_farPtrExeLocSegOffset;
	s_obj_gate1.compatdospointer = 0x1A7E0000 + g_farPtrExeLocSegOffset;
	s_obj_gate2.compatdospointer = 0x1A7F0000 + g_farPtrExeLocSegOffset;
	s_obj_gate3.compatdospointer = 0x1A800000 + g_farPtrExeLocSegOffset;
	s_obj_gate4.compatdospointer = 0x1A810000 + g_farPtrExeLocSegOffset;
	s_anthill.compatdospointer = 0x1A820000 + g_farPtrExeLocSegOffset;
	s_fatdemon_pause.compatdospointer = 0x1A830000 + g_farPtrExeLocSegOffset;
	s_fatdemon_walk1.compatdospointer = 0x1A840000 + g_farPtrExeLocSegOffset;
	s_fatdemon_walk2.compatdospointer = 0x1A850000 + g_farPtrExeLocSegOffset;
	s_fatdemon_walk3.compatdospointer = 0x1A860000 + g_farPtrExeLocSegOffset;
	s_fatdemon_walk4.compatdospointer = 0x1A870000 + g_farPtrExeLocSegOffset;
	s_fatdemon_attack1.compatdospointer = 0x1A880000 + g_farPtrExeLocSegOffset;
	s_fatdemon_attack2.compatdospointer = 0x1A890000 + g_farPtrExeLocSegOffset;
	s_fatdemon_ouch.compatdospointer = 0x1A8A0000 + g_farPtrExeLocSegOffset;
	s_fatdemon_blowup1.compatdospointer = 0x1A8B0000 + g_farPtrExeLocSegOffset;
	s_fatdemon_blowup2.compatdospointer = 0x1A8C0000 + g_farPtrExeLocSegOffset;
	s_fatdemon_blowup3.compatdospointer = 0x1A8D0000 + g_farPtrExeLocSegOffset;
	s_fatdemon_blowup4.compatdospointer = 0x1A8E0000 + g_farPtrExeLocSegOffset;
	s_fatdemon_blowup5.compatdospointer = 0x1A8F0000 + g_farPtrExeLocSegOffset;
	s_fatdemon_blowup6.compatdospointer = 0x1A900000 + g_farPtrExeLocSegOffset;
	s_fatdemon_blowup7.compatdospointer = 0x1A910000 + g_farPtrExeLocSegOffset;
	s_fatdemon_explode.compatdospointer = 0x1A920000 + g_farPtrExeLocSegOffset;
	s_fatdemon_feet.compatdospointer = 0x1A930000 + g_farPtrExeLocSegOffset;
	s_wet_bubbles1.compatdospointer = 0x1A940000 + g_farPtrExeLocSegOffset;
	s_wet_bubbles2.compatdospointer = 0x1A950000 + g_farPtrExeLocSegOffset;
	s_wet_bubbles3.compatdospointer = 0x1A960000 + g_farPtrExeLocSegOffset;
	s_wet_peek.compatdospointer = 0x1A970000 + g_farPtrExeLocSegOffset;
	s_wet_rise1.compatdospointer = 0x1A980000 + g_farPtrExeLocSegOffset;
	s_wet_rise3.compatdospointer = 0x1A990000 + g_farPtrExeLocSegOffset;
	s_wet_rise4.compatdospointer = 0x1A9A0000 + g_farPtrExeLocSegOffset;
	s_wet_rise5.compatdospointer = 0x1A9B0000 + g_farPtrExeLocSegOffset;
	s_wet_sink1.compatdospointer = 0x1A9C0000 + g_farPtrExeLocSegOffset;
	s_wet_sink2.compatdospointer = 0x1A9D0000 + g_farPtrExeLocSegOffset;
	s_wet_sink3.compatdospointer = 0x1A9E0000 + g_farPtrExeLocSegOffset;
	s_wet_walk1.compatdospointer = 0x1A9F0000 + g_farPtrExeLocSegOffset;
	s_wet_walk2.compatdospointer = 0x1AA00000 + g_farPtrExeLocSegOffset;
	s_wet_walk3.compatdospointer = 0x1AA10000 + g_farPtrExeLocSegOffset;
	s_wet_walk4.compatdospointer = 0x1AA20000 + g_farPtrExeLocSegOffset;
	s_wet_attack1.compatdospointer = 0x1AA30000 + g_farPtrExeLocSegOffset;
	s_wet_attack2.compatdospointer = 0x1AA40000 + g_farPtrExeLocSegOffset;
	s_wet_attack3.compatdospointer = 0x1AA50000 + g_farPtrExeLocSegOffset;
	s_wet_attack4.compatdospointer = 0x1AA60000 + g_farPtrExeLocSegOffset;
	s_wet_ouch.compatdospointer = 0x1AA70000 + g_farPtrExeLocSegOffset;
	s_wet_die1.compatdospointer = 0x1AA80000 + g_farPtrExeLocSegOffset;
	s_wet_die2.compatdospointer = 0x1AA90000 + g_farPtrExeLocSegOffset;
	s_wet_die3.compatdospointer = 0x1AAA0000 + g_farPtrExeLocSegOffset;
	s_wet_die4.compatdospointer = 0x1AAB0000 + g_farPtrExeLocSegOffset;
	s_wet_die5.compatdospointer = 0x1AAC0000 + g_farPtrExeLocSegOffset;
	s_dragon_shot1.compatdospointer = 0x1AAD0000 + g_farPtrExeLocSegOffset;
	s_dragon_shot2.compatdospointer = 0x1AAE0000 + g_farPtrExeLocSegOffset;
	s_wallskel.compatdospointer = 0x1AAF0000 + g_farPtrExeLocSegOffset;
	s_wallskel2.compatdospointer = 0x1AB00000 + g_farPtrExeLocSegOffset;
	s_skel_pause.compatdospointer = 0x1AB10000 + g_farPtrExeLocSegOffset;
	s_skel_1.compatdospointer = 0x1AB20000 + g_farPtrExeLocSegOffset;
	s_skel_2.compatdospointer = 0x1AB30000 + g_farPtrExeLocSegOffset;
	s_skel_3.compatdospointer = 0x1AB40000 + g_farPtrExeLocSegOffset;
	s_skel_4.compatdospointer = 0x1AB50000 + g_farPtrExeLocSegOffset;
	s_skel_attack1.compatdospointer = 0x1AB60000 + g_farPtrExeLocSegOffset;
	s_skel_attack2.compatdospointer = 0x1AB70000 + g_farPtrExeLocSegOffset;
	s_skel_attack3.compatdospointer = 0x1AB80000 + g_farPtrExeLocSegOffset;
	s_skel_ouch.compatdospointer = 0x1AB90000 + g_farPtrExeLocSegOffset;
	s_skel_die1.compatdospointer = 0x1ABA0000 + g_farPtrExeLocSegOffset;
	s_skel_die2.compatdospointer = 0x1ABB0000 + g_farPtrExeLocSegOffset;
	s_skel_die3.compatdospointer = 0x1ABC0000 + g_farPtrExeLocSegOffset;
	s_eye_pause.compatdospointer = 0x1ABD0000 + g_farPtrExeLocSegOffset;
	s_eye_1.compatdospointer = 0x1ABE0000 + g_farPtrExeLocSegOffset;
	s_eye_2.compatdospointer = 0x1ABF0000 + g_farPtrExeLocSegOffset;
	s_eye_3.compatdospointer = 0x1AC00000 + g_farPtrExeLocSegOffset;
	s_eye_4.compatdospointer = 0x1AC10000 + g_farPtrExeLocSegOffset;
	s_eye_shootplayer_1.compatdospointer = 0x1AC20000 + g_farPtrExeLocSegOffset;
	s_eye_shootplayer_2.compatdospointer = 0x1AC30000 + g_farPtrExeLocSegOffset;
	s_eye_ouch.compatdospointer = 0x1AC40000 + g_farPtrExeLocSegOffset;
	s_eye_ouch2.compatdospointer = 0x1AC50000 + g_farPtrExeLocSegOffset;
	s_eye_die1.compatdospointer = 0x1AC60000 + g_farPtrExeLocSegOffset;
	s_eye_die2.compatdospointer = 0x1AC70000 + g_farPtrExeLocSegOffset;
	s_eye_die3.compatdospointer = 0x1AC80000 + g_farPtrExeLocSegOffset;
	s_eshot1.compatdospointer = 0x1AC90000 + g_farPtrExeLocSegOffset;
	s_eshot2.compatdospointer = 0x1ACA0000 + g_farPtrExeLocSegOffset;
	s_succubus_pause.compatdospointer = 0x1ACB0000 + g_farPtrExeLocSegOffset;
	s_succubus_walk1.compatdospointer = 0x1ACC0000 + g_farPtrExeLocSegOffset;
	s_succubus_walk2.compatdospointer = 0x1ACD0000 + g_farPtrExeLocSegOffset;
	s_succubus_walk3.compatdospointer = 0x1ACE0000 + g_farPtrExeLocSegOffset;
	s_succubus_walk4.compatdospointer = 0x1ACF0000 + g_farPtrExeLocSegOffset;
	s_succubus_attack1.compatdospointer = 0x1AD00000 + g_farPtrExeLocSegOffset;
	s_succubus_attack2.compatdospointer = 0x1AD10000 + g_farPtrExeLocSegOffset;
	s_succubus_attack3.compatdospointer = 0x1AD20000 + g_farPtrExeLocSegOffset;
	s_succubus_ouch.compatdospointer = 0x1AD30000 + g_farPtrExeLocSegOffset;
	s_succubus_death1.compatdospointer = 0x1AD40000 + g_farPtrExeLocSegOffset;
	s_succubus_death2.compatdospointer = 0x1AD50000 + g_farPtrExeLocSegOffset;
	s_succubus_shot1.compatdospointer = 0x1AD60000 + g_farPtrExeLocSegOffset;
	s_magepause.compatdospointer = 0x1AD70000 + g_farPtrExeLocSegOffset;
	s_mage1.compatdospointer = 0x1AD80000 + g_farPtrExeLocSegOffset;
	s_mage2.compatdospointer = 0x1AD90000 + g_farPtrExeLocSegOffset;
	s_mageattack3.compatdospointer = 0x1ADA0000 + g_farPtrExeLocSegOffset;
	s_mageouch.compatdospointer = 0x1ADB0000 + g_farPtrExeLocSegOffset;
	s_magedie1.compatdospointer = 0x1ADC0000 + g_farPtrExeLocSegOffset;
	s_magedie2.compatdospointer = 0x1ADD0000 + g_farPtrExeLocSegOffset;
	s_mshot1.compatdospointer = 0x1ADE0000 + g_farPtrExeLocSegOffset;
	s_mshot2.compatdospointer = 0x1ADF0000 + g_farPtrExeLocSegOffset;
	s_bunny_left1.compatdospointer = 0x1AE00000 + g_farPtrExeLocSegOffset;
	s_bunny_left2.compatdospointer = 0x1AE10000 + g_farPtrExeLocSegOffset;
	s_bunny_left3.compatdospointer = 0x1AE20000 + g_farPtrExeLocSegOffset;
	s_bunny_right1.compatdospointer = 0x1AE30000 + g_farPtrExeLocSegOffset;
	s_bunny_right2.compatdospointer = 0x1AE40000 + g_farPtrExeLocSegOffset;
	s_bunny_right3.compatdospointer = 0x1AE50000 + g_farPtrExeLocSegOffset;
	s_bunny_meta1.compatdospointer = 0x1AE60000 + g_farPtrExeLocSegOffset;
	s_bunny_meta2.compatdospointer = 0x1AE70000 + g_farPtrExeLocSegOffset;
	s_bunny_walk1.compatdospointer = 0x1AE80000 + g_farPtrExeLocSegOffset;
	s_bunny_walk2.compatdospointer = 0x1AE90000 + g_farPtrExeLocSegOffset;
	s_bunny_attack1.compatdospointer = 0x1AEA0000 + g_farPtrExeLocSegOffset;
	s_bunny_attack2.compatdospointer = 0x1AEB0000 + g_farPtrExeLocSegOffset;
	s_bunny_ouch.compatdospointer = 0x1AEC0000 + g_farPtrExeLocSegOffset;
	s_bunny_pause.compatdospointer = 0x1AED0000 + g_farPtrExeLocSegOffset;
	s_bunny_death1.compatdospointer = 0x1AEE0000 + g_farPtrExeLocSegOffset;
	s_bunny_death2.compatdospointer = 0x1AEF0000 + g_farPtrExeLocSegOffset;
	s_bunny_death3.compatdospointer = 0x1AF00000 + g_farPtrExeLocSegOffset;
	s_red_demonpause.compatdospointer = 0x1AF10000 + g_farPtrExeLocSegOffset;
	s_red_demon1.compatdospointer = 0x1AF20000 + g_farPtrExeLocSegOffset;
	s_red_demon2.compatdospointer = 0x1AF30000 + g_farPtrExeLocSegOffset;
	s_red_demon3.compatdospointer = 0x1AF40000 + g_farPtrExeLocSegOffset;
	s_red_demon4.compatdospointer = 0x1AF50000 + g_farPtrExeLocSegOffset;
	s_red_demonattack1.compatdospointer = 0x1AF60000 + g_farPtrExeLocSegOffset;
	s_red_demonattack2.compatdospointer = 0x1AF70000 + g_farPtrExeLocSegOffset;
	s_red_demonattack3.compatdospointer = 0x1AF80000 + g_farPtrExeLocSegOffset;
	s_red_demonouch.compatdospointer = 0x1AF90000 + g_farPtrExeLocSegOffset;
	s_red_demondie1.compatdospointer = 0x1AFA0000 + g_farPtrExeLocSegOffset;
	s_red_demondie2.compatdospointer = 0x1AFB0000 + g_farPtrExeLocSegOffset;
	s_red_demondie3.compatdospointer = 0x1AFC0000 + g_farPtrExeLocSegOffset;
	s_red_demondie4.compatdospointer = 0x1AFD0000 + g_farPtrExeLocSegOffset;
	s_grelpause.compatdospointer = 0x1AFE0000 + g_farPtrExeLocSegOffset;
	s_grel1.compatdospointer = 0x1AFF0000 + g_farPtrExeLocSegOffset;
	s_grel2.compatdospointer = 0x1B000000 + g_farPtrExeLocSegOffset;
	s_grelattack3.compatdospointer = 0x1B010000 + g_farPtrExeLocSegOffset;
	s_grelouch.compatdospointer = 0x1B020000 + g_farPtrExeLocSegOffset;
	s_greldie1.compatdospointer = 0x1B030000 + g_farPtrExeLocSegOffset;
	s_greldie2.compatdospointer = 0x1B040000 + g_farPtrExeLocSegOffset;
	s_greldie3.compatdospointer = 0x1B050000 + g_farPtrExeLocSegOffset;
	s_greldie4.compatdospointer = 0x1B060000 + g_farPtrExeLocSegOffset;
	s_greldie5.compatdospointer = 0x1B070000 + g_farPtrExeLocSegOffset;
	s_greldie5a.compatdospointer = 0x1B080000 + g_farPtrExeLocSegOffset;
	s_greldie6.compatdospointer = 0x1B090000 + g_farPtrExeLocSegOffset;
	s_gshot1.compatdospointer = 0x1B0A0000 + g_farPtrExeLocSegOffset;
	s_bat1.compatdospointer = 0x1B0B0000 + g_farPtrExeLocSegOffset;
	s_bat2.compatdospointer = 0x1B0C0000 + g_farPtrExeLocSegOffset;
	s_bat3.compatdospointer = 0x1B0D0000 + g_farPtrExeLocSegOffset;
	s_bat4.compatdospointer = 0x1B0E0000 + g_farPtrExeLocSegOffset;
	s_batpast.compatdospointer = 0x1B0F0000 + g_farPtrExeLocSegOffset;
	s_batdie1.compatdospointer = 0x1B100000 + g_farPtrExeLocSegOffset;
	s_batdie2.compatdospointer = 0x1B110000 + g_farPtrExeLocSegOffset;
	s_godesspause.compatdospointer = 0x1B120000 + g_farPtrExeLocSegOffset;
	s_godess_statue1.compatdospointer = 0x1B130000 + g_farPtrExeLocSegOffset;
	s_godess_statue2.compatdospointer = 0x1B140000 + g_farPtrExeLocSegOffset;
	s_godess1.compatdospointer = 0x1B150000 + g_farPtrExeLocSegOffset;
	s_godess2.compatdospointer = 0x1B160000 + g_farPtrExeLocSegOffset;
	s_godess3.compatdospointer = 0x1B170000 + g_farPtrExeLocSegOffset;
	s_godessattack1.compatdospointer = 0x1B180000 + g_farPtrExeLocSegOffset;
	s_godessattack2.compatdospointer = 0x1B190000 + g_farPtrExeLocSegOffset;
	s_godessattack3.compatdospointer = 0x1B1A0000 + g_farPtrExeLocSegOffset;
	s_godessouch.compatdospointer = 0x1B1B0000 + g_farPtrExeLocSegOffset;
	s_godessdie1.compatdospointer = 0x1B1C0000 + g_farPtrExeLocSegOffset;
	s_godessdie2.compatdospointer = 0x1B1D0000 + g_farPtrExeLocSegOffset;
	s_ant_wait.compatdospointer = 0x1B1E0000 + g_farPtrExeLocSegOffset;
	s_ant_egg.compatdospointer = 0x1B1F0000 + g_farPtrExeLocSegOffset;
	s_ant_walk1.compatdospointer = 0x1B200000 + g_farPtrExeLocSegOffset;
	s_ant_walk2.compatdospointer = 0x1B210000 + g_farPtrExeLocSegOffset;
	s_ant_walk3.compatdospointer = 0x1B220000 + g_farPtrExeLocSegOffset;
	s_ant_attack1.compatdospointer = 0x1B230000 + g_farPtrExeLocSegOffset;
	s_ant_pause.compatdospointer = 0x1B240000 + g_farPtrExeLocSegOffset;
	s_ant_ouch.compatdospointer = 0x1B250000 + g_farPtrExeLocSegOffset;
	s_ant_die1.compatdospointer = 0x1B260000 + g_farPtrExeLocSegOffset;
	s_ant_die2.compatdospointer = 0x1B270000 + g_farPtrExeLocSegOffset;
	s_ant_die3.compatdospointer = 0x1B280000 + g_farPtrExeLocSegOffset;
	s_zombie_risen.compatdospointer = 0x1B290000 + g_farPtrExeLocSegOffset;
	s_zombie_pause.compatdospointer = 0x1B2A0000 + g_farPtrExeLocSegOffset;
	s_zombie_inground.compatdospointer = 0x1B2B0000 + g_farPtrExeLocSegOffset;
	s_zombie_rise1.compatdospointer = 0x1B2C0000 + g_farPtrExeLocSegOffset;
	s_zombie_rise2.compatdospointer = 0x1B2D0000 + g_farPtrExeLocSegOffset;
	s_zombie_rise3.compatdospointer = 0x1B2E0000 + g_farPtrExeLocSegOffset;
	s_zombie_rise4.compatdospointer = 0x1B2F0000 + g_farPtrExeLocSegOffset;
	s_zombie_alive1.compatdospointer = 0x1B300000 + g_farPtrExeLocSegOffset;
	s_zombie_alive2.compatdospointer = 0x1B310000 + g_farPtrExeLocSegOffset;
	s_zombie_alive3.compatdospointer = 0x1B320000 + g_farPtrExeLocSegOffset;
	s_zombie_death1.compatdospointer = 0x1B330000 + g_farPtrExeLocSegOffset;
	s_zombie_death2.compatdospointer = 0x1B340000 + g_farPtrExeLocSegOffset;
	s_zombie_death3.compatdospointer = 0x1B350000 + g_farPtrExeLocSegOffset;
	s_zombie_attack.compatdospointer = 0x1B360000 + g_farPtrExeLocSegOffset;
	s_zombie_ouch.compatdospointer = 0x1B370000 + g_farPtrExeLocSegOffset;
	s_tree_pause.compatdospointer = 0x1B380000 + g_farPtrExeLocSegOffset;
	s_tree_idle.compatdospointer = 0x1B390000 + g_farPtrExeLocSegOffset;
	s_tree_awakening1.compatdospointer = 0x1B3A0000 + g_farPtrExeLocSegOffset;
	s_tree_awakening2.compatdospointer = 0x1B3B0000 + g_farPtrExeLocSegOffset;
	s_tree_walk1.compatdospointer = 0x1B3C0000 + g_farPtrExeLocSegOffset;
	s_tree_walk2.compatdospointer = 0x1B3D0000 + g_farPtrExeLocSegOffset;
	s_tree_death1.compatdospointer = 0x1B3E0000 + g_farPtrExeLocSegOffset;
	s_tree_death2.compatdospointer = 0x1B3F0000 + g_farPtrExeLocSegOffset;
	s_tree_death3.compatdospointer = 0x1B400000 + g_farPtrExeLocSegOffset;
	s_tree_death4.compatdospointer = 0x1B410000 + g_farPtrExeLocSegOffset;
	s_tree_death5.compatdospointer = 0x1B420000 + g_farPtrExeLocSegOffset;
	s_tree_attack1.compatdospointer = 0x1B430000 + g_farPtrExeLocSegOffset;
	s_tree_attack2.compatdospointer = 0x1B440000 + g_farPtrExeLocSegOffset;
	s_tree_attack3.compatdospointer = 0x1B450000 + g_farPtrExeLocSegOffset;
	s_tree_ouch.compatdospointer = 0x1B460000 + g_farPtrExeLocSegOffset;
	s_arch_1.compatdospointer = 0x1B470000 + g_farPtrExeLocSegOffset;
	s_arch_2.compatdospointer = 0x1B480000 + g_farPtrExeLocSegOffset;
	s_arch_3.compatdospointer = 0x1B490000 + g_farPtrExeLocSegOffset;
	s_arch_4.compatdospointer = 0x1B4A0000 + g_farPtrExeLocSegOffset;
	s_arch_5.compatdospointer = 0x1B4B0000 + g_farPtrExeLocSegOffset;
	s_arch_6.compatdospointer = 0x1B4C0000 + g_farPtrExeLocSegOffset;
	s_arch_7.compatdospointer = 0x1B4D0000 + g_farPtrExeLocSegOffset;
	s_arch_8.compatdospointer = 0x1B4E0000 + g_farPtrExeLocSegOffset;
	s_arch_9.compatdospointer = 0x1B4F0000 + g_farPtrExeLocSegOffset;
	s_arch_10.compatdospointer = 0x1B500000 + g_farPtrExeLocSegOffset;
	s_arch_11.compatdospointer = 0x1B510000 + g_farPtrExeLocSegOffset;
	s_arch_12.compatdospointer = 0x1B520000 + g_farPtrExeLocSegOffset;
	s_arch_13.compatdospointer = 0x1B530000 + g_farPtrExeLocSegOffset;
	s_column.compatdospointer = 0x1B540000 + g_farPtrExeLocSegOffset;
	s_sulphur_gas_1.compatdospointer = 0x1B550000 + g_farPtrExeLocSegOffset;
	s_sulphur_gas_2.compatdospointer = 0x1B560000 + g_farPtrExeLocSegOffset;
	s_sulphur_gas_3.compatdospointer = 0x1B570000 + g_farPtrExeLocSegOffset;
	s_fire_pot_1.compatdospointer = 0x1B580000 + g_farPtrExeLocSegOffset;
	s_fire_pot_2.compatdospointer = 0x1B590000 + g_farPtrExeLocSegOffset;
	s_fountain.compatdospointer = 0x1B5A0000 + g_farPtrExeLocSegOffset;
	s_force_field_1.compatdospointer = 0x1B5B0000 + g_farPtrExeLocSegOffset;
	s_force_field_2.compatdospointer = 0x1B5C0000 + g_farPtrExeLocSegOffset;
	s_force_field_3.compatdospointer = 0x1B5D0000 + g_farPtrExeLocSegOffset;
	s_force_field_4.compatdospointer = 0x1B5E0000 + g_farPtrExeLocSegOffset;
	s_force_field_die.compatdospointer = 0x1B5F0000 + g_farPtrExeLocSegOffset;
	s_force_field_die1.compatdospointer = 0x1B600000 + g_farPtrExeLocSegOffset;
	s_skeleton_hanging.compatdospointer = 0x1B610000 + g_farPtrExeLocSegOffset;
}

static statetype *RefKeen_GetObjStatePtrFromDOSPointer_CatArm102(uint_fast32_t dosptr)
{
	switch (dosptr - g_farPtrExeLocSegOffset)
	{
	case 0x1A530000: return &s_pshot1;
	case 0x1A540000: return &s_pshot2;
	case 0x1A550000: return &s_pshot_exp1;
	case 0x1A560000: return &s_pshot_exp2;
	case 0x1A570000: return &s_pshot_exp3;
	case 0x1A580000: return &s_player;
	case 0x1A590000: return &s_explode;
	case 0x1A5A0000: return &s_boltbonus;
	case 0x1A5B0000: return &s_boltbonus2;
	case 0x1A5C0000: return &s_boltbonus3;
	case 0x1A5D0000: return &s_nukebonus;
	case 0x1A5E0000: return &s_nukebonus2;
	case 0x1A5F0000: return &s_nukebonus3;
	case 0x1A600000: return &s_potionbonus;
	case 0x1A610000: return &s_rkeybonus;
	case 0x1A620000: return &s_ykeybonus;
	case 0x1A630000: return &s_gkeybonus;
	case 0x1A640000: return &s_bkeybonus;
	case 0x1A650000: return &s_chestbonus;
	case 0x1A660000: return &s_waterchestbonus1;
	case 0x1A670000: return &s_waterchestbonus2;
	case 0x1A680000: return &s_rgem1bonus;
	case 0x1A690000: return &s_ygem1bonus;
	case 0x1A6A0000: return &s_ggem1bonus;
	case 0x1A6B0000: return &s_bgem1bonus;
	case 0x1A6C0000: return &s_pgem1bonus;
	case 0x1A6D0000: return &s_rgem2bonus;
	case 0x1A6E0000: return &s_ygem2bonus;
	case 0x1A6F0000: return &s_ggem2bonus;
	case 0x1A700000: return &s_bgem2bonus;
	case 0x1A710000: return &s_pgem2bonus;
	case 0x1A720000: return &s_bonus_die;
	case 0x1A730000: return &s_tombs[0];
	case 0x1A740000: return &s_tombs[1];
	case 0x1A750000: return &s_tombs[2];
	case 0x1A760000: return &s_ftimebonus;
	case 0x1A770000: return &s_ftimebonus2;
	case 0x1A780000: return &s_walldie1;
	case 0x1A790000: return &s_walldie2;
	case 0x1A7A0000: return &s_walldie3;
	case 0x1A7B0000: return &s_walldie4;
	case 0x1A7C0000: return &s_walldie5;
	case 0x1A7D0000: return &s_walldie6;
	case 0x1A7E0000: return &s_obj_gate1;
	case 0x1A7F0000: return &s_obj_gate2;
	case 0x1A800000: return &s_obj_gate3;
	case 0x1A810000: return &s_obj_gate4;
	case 0x1A820000: return &s_anthill;
	case 0x1A830000: return &s_fatdemon_pause;
	case 0x1A840000: return &s_fatdemon_walk1;
	case 0x1A850000: return &s_fatdemon_walk2;
	case 0x1A860000: return &s_fatdemon_walk3;
	case 0x1A870000: return &s_fatdemon_walk4;
	case 0x1A880000: return &s_fatdemon_attack1;
	case 0x1A890000: return &s_fatdemon_attack2;
	case 0x1A8A0000: return &s_fatdemon_ouch;
	case 0x1A8B0000: return &s_fatdemon_blowup1;
	case 0x1A8C0000: return &s_fatdemon_blowup2;
	case 0x1A8D0000: return &s_fatdemon_blowup3;
	case 0x1A8E0000: return &s_fatdemon_blowup4;
	case 0x1A8F0000: return &s_fatdemon_blowup5;
	case 0x1A900000: return &s_fatdemon_blowup6;
	case 0x1A910000: return &s_fatdemon_blowup7;
	case 0x1A920000: return &s_fatdemon_explode;
	case 0x1A930000: return &s_fatdemon_feet;
	case 0x1A940000: return &s_wet_bubbles1;
	case 0x1A950000: return &s_wet_bubbles2;
	case 0x1A960000: return &s_wet_bubbles3;
	case 0x1A970000: return &s_wet_peek;
	case 0x1A980000: return &s_wet_rise1;
	case 0x1A990000: return &s_wet_rise3;
	case 0x1A9A0000: return &s_wet_rise4;
	case 0x1A9B0000: return &s_wet_rise5;
	case 0x1A9C0000: return &s_wet_sink1;
	case 0x1A9D0000: return &s_wet_sink2;
	case 0x1A9E0000: return &s_wet_sink3;
	case 0x1A9F0000: return &s_wet_walk1;
	case 0x1AA00000: return &s_wet_walk2;
	case 0x1AA10000: return &s_wet_walk3;
	case 0x1AA20000: return &s_wet_walk4;
	case 0x1AA30000: return &s_wet_attack1;
	case 0x1AA40000: return &s_wet_attack2;
	case 0x1AA50000: return &s_wet_attack3;
	case 0x1AA60000: return &s_wet_attack4;
	case 0x1AA70000: return &s_wet_ouch;
	case 0x1AA80000: return &s_wet_die1;
	case 0x1AA90000: return &s_wet_die2;
	case 0x1AAA0000: return &s_wet_die3;
	case 0x1AAB0000: return &s_wet_die4;
	case 0x1AAC0000: return &s_wet_die5;
	case 0x1AAD0000: return &s_dragon_shot1;
	case 0x1AAE0000: return &s_dragon_shot2;
	case 0x1AAF0000: return &s_wallskel;
	case 0x1AB00000: return &s_wallskel2;
	case 0x1AB10000: return &s_skel_pause;
	case 0x1AB20000: return &s_skel_1;
	case 0x1AB30000: return &s_skel_2;
	case 0x1AB40000: return &s_skel_3;
	case 0x1AB50000: return &s_skel_4;
	case 0x1AB60000: return &s_skel_attack1;
	case 0x1AB70000: return &s_skel_attack2;
	case 0x1AB80000: return &s_skel_attack3;
	case 0x1AB90000: return &s_skel_ouch;
	case 0x1ABA0000: return &s_skel_die1;
	case 0x1ABB0000: return &s_skel_die2;
	case 0x1ABC0000: return &s_skel_die3;
	case 0x1ABD0000: return &s_eye_pause;
	case 0x1ABE0000: return &s_eye_1;
	case 0x1ABF0000: return &s_eye_2;
	case 0x1AC00000: return &s_eye_3;
	case 0x1AC10000: return &s_eye_4;
	case 0x1AC20000: return &s_eye_shootplayer_1;
	case 0x1AC30000: return &s_eye_shootplayer_2;
	case 0x1AC40000: return &s_eye_ouch;
	case 0x1AC50000: return &s_eye_ouch2;
	case 0x1AC60000: return &s_eye_die1;
	case 0x1AC70000: return &s_eye_die2;
	case 0x1AC80000: return &s_eye_die3;
	case 0x1AC90000: return &s_eshot1;
	case 0x1ACA0000: return &s_eshot2;
	case 0x1ACB0000: return &s_succubus_pause;
	case 0x1ACC0000: return &s_succubus_walk1;
	case 0x1ACD0000: return &s_succubus_walk2;
	case 0x1ACE0000: return &s_succubus_walk3;
	case 0x1ACF0000: return &s_succubus_walk4;
	case 0x1AD00000: return &s_succubus_attack1;
	case 0x1AD10000: return &s_succubus_attack2;
	case 0x1AD20000: return &s_succubus_attack3;
	case 0x1AD30000: return &s_succubus_ouch;
	case 0x1AD40000: return &s_succubus_death1;
	case 0x1AD50000: return &s_succubus_death2;
	case 0x1AD60000: return &s_succubus_shot1;
	case 0x1AD70000: return &s_magepause;
	case 0x1AD80000: return &s_mage1;
	case 0x1AD90000: return &s_mage2;
	case 0x1ADA0000: return &s_mageattack3;
	case 0x1ADB0000: return &s_mageouch;
	case 0x1ADC0000: return &s_magedie1;
	case 0x1ADD0000: return &s_magedie2;
	case 0x1ADE0000: return &s_mshot1;
	case 0x1ADF0000: return &s_mshot2;
	case 0x1AE00000: return &s_bunny_left1;
	case 0x1AE10000: return &s_bunny_left2;
	case 0x1AE20000: return &s_bunny_left3;
	case 0x1AE30000: return &s_bunny_right1;
	case 0x1AE40000: return &s_bunny_right2;
	case 0x1AE50000: return &s_bunny_right3;
	case 0x1AE60000: return &s_bunny_meta1;
	case 0x1AE70000: return &s_bunny_meta2;
	case 0x1AE80000: return &s_bunny_walk1;
	case 0x1AE90000: return &s_bunny_walk2;
	case 0x1AEA0000: return &s_bunny_attack1;
	case 0x1AEB0000: return &s_bunny_attack2;
	case 0x1AEC0000: return &s_bunny_ouch;
	case 0x1AED0000: return &s_bunny_pause;
	case 0x1AEE0000: return &s_bunny_death1;
	case 0x1AEF0000: return &s_bunny_death2;
	case 0x1AF00000: return &s_bunny_death3;
	case 0x1AF10000: return &s_red_demonpause;
	case 0x1AF20000: return &s_red_demon1;
	case 0x1AF30000: return &s_red_demon2;
	case 0x1AF40000: return &s_red_demon3;
	case 0x1AF50000: return &s_red_demon4;
	case 0x1AF60000: return &s_red_demonattack1;
	case 0x1AF70000: return &s_red_demonattack2;
	case 0x1AF80000: return &s_red_demonattack3;
	case 0x1AF90000: return &s_red_demonouch;
	case 0x1AFA0000: return &s_red_demondie1;
	case 0x1AFB0000: return &s_red_demondie2;
	case 0x1AFC0000: return &s_red_demondie3;
	case 0x1AFD0000: return &s_red_demondie4;
	case 0x1AFE0000: return &s_grelpause;
	case 0x1AFF0000: return &s_grel1;
	case 0x1B000000: return &s_grel2;
	case 0x1B010000: return &s_grelattack3;
	case 0x1B020000: return &s_grelouch;
	case 0x1B030000: return &s_greldie1;
	case 0x1B040000: return &s_greldie2;
	case 0x1B050000: return &s_greldie3;
	case 0x1B060000: return &s_greldie4;
	case 0x1B070000: return &s_greldie5;
	case 0x1B080000: return &s_greldie5a;
	case 0x1B090000: return &s_greldie6;
	case 0x1B0A0000: return &s_gshot1;
	case 0x1B0B0000: return &s_bat1;
	case 0x1B0C0000: return &s_bat2;
	case 0x1B0D0000: return &s_bat3;
	case 0x1B0E0000: return &s_bat4;
	case 0x1B0F0000: return &s_batpast;
	case 0x1B100000: return &s_batdie1;
	case 0x1B110000: return &s_batdie2;
	case 0x1B120000: return &s_godesspause;
	case 0x1B130000: return &s_godess_statue1;
	case 0x1B140000: return &s_godess_statue2;
	case 0x1B150000: return &s_godess1;
	case 0x1B160000: return &s_godess2;
	case 0x1B170000: return &s_godess3;
	case 0x1B180000: return &s_godessattack1;
	case 0x1B190000: return &s_godessattack2;
	case 0x1B1A0000: return &s_godessattack3;
	case 0x1B1B0000: return &s_godessouch;
	case 0x1B1C0000: return &s_godessdie1;
	case 0x1B1D0000: return &s_godessdie2;
	case 0x1B1E0000: return &s_ant_wait;
	case 0x1B1F0000: return &s_ant_egg;
	case 0x1B200000: return &s_ant_walk1;
	case 0x1B210000: return &s_ant_walk2;
	case 0x1B220000: return &s_ant_walk3;
	case 0x1B230000: return &s_ant_attack1;
	case 0x1B240000: return &s_ant_pause;
	case 0x1B250000: return &s_ant_ouch;
	case 0x1B260000: return &s_ant_die1;
	case 0x1B270000: return &s_ant_die2;
	case 0x1B280000: return &s_ant_die3;
	case 0x1B290000: return &s_zombie_risen;
	case 0x1B2A0000: return &s_zombie_pause;
	case 0x1B2B0000: return &s_zombie_inground;
	case 0x1B2C0000: return &s_zombie_rise1;
	case 0x1B2D0000: return &s_zombie_rise2;
	case 0x1B2E0000: return &s_zombie_rise3;
	case 0x1B2F0000: return &s_zombie_rise4;
	case 0x1B300000: return &s_zombie_alive1;
	case 0x1B310000: return &s_zombie_alive2;
	case 0x1B320000: return &s_zombie_alive3;
	case 0x1B330000: return &s_zombie_death1;
	case 0x1B340000: return &s_zombie_death2;
	case 0x1B350000: return &s_zombie_death3;
	case 0x1B360000: return &s_zombie_attack;
	case 0x1B370000: return &s_zombie_ouch;
	case 0x1B380000: return &s_tree_pause;
	case 0x1B390000: return &s_tree_idle;
	case 0x1B3A0000: return &s_tree_awakening1;
	case 0x1B3B0000: return &s_tree_awakening2;
	case 0x1B3C0000: return &s_tree_walk1;
	case 0x1B3D0000: return &s_tree_walk2;
	case 0x1B3E0000: return &s_tree_death1;
	case 0x1B3F0000: return &s_tree_death2;
	case 0x1B400000: return &s_tree_death3;
	case 0x1B410000: return &s_tree_death4;
	case 0x1B420000: return &s_tree_death5;
	case 0x1B430000: return &s_tree_attack1;
	case 0x1B440000: return &s_tree_attack2;
	case 0x1B450000: return &s_tree_attack3;
	case 0x1B460000: return &s_tree_ouch;
	case 0x1B470000: return &s_arch_1;
	case 0x1B480000: return &s_arch_2;
	case 0x1B490000: return &s_arch_3;
	case 0x1B4A0000: return &s_arch_4;
	case 0x1B4B0000: return &s_arch_5;
	case 0x1B4C0000: return &s_arch_6;
	case 0x1B4D0000: return &s_arch_7;
	case 0x1B4E0000: return &s_arch_8;
	case 0x1B4F0000: return &s_arch_9;
	case 0x1B500000: return &s_arch_10;
	case 0x1B510000: return &s_arch_11;
	case 0x1B520000: return &s_arch_12;
	case 0x1B530000: return &s_arch_13;
	case 0x1B540000: return &s_column;
	case 0x1B550000: return &s_sulphur_gas_1;
	case 0x1B560000: return &s_sulphur_gas_2;
	case 0x1B570000: return &s_sulphur_gas_3;
	case 0x1B580000: return &s_fire_pot_1;
	case 0x1B590000: return &s_fire_pot_2;
	case 0x1B5A0000: return &s_fountain;
	case 0x1B5B0000: return &s_force_field_1;
	case 0x1B5C0000: return &s_force_field_2;
	case 0x1B5D0000: return &s_force_field_3;
	case 0x1B5E0000: return &s_force_field_4;
	case 0x1B5F0000: return &s_force_field_die;
	case 0x1B600000: return &s_force_field_die1;
	case 0x1B610000: return &s_skeleton_hanging;
	}
	return NULL;
}

REFKEEN_NS_E
